#!/usr/bin/env python

# this script loads the iqportal settings file and for each app it checkes the version requirements of the packages
# and checks if the writable dirs exist and are writable

import getopt, sys

from basesoft.web.core.util.dependencies import Requirements

def help():
    print 'Checks if all the installed apps have the required dependencies'
    print 'Usage: check_dependencies.py'

def main():
    try:
        opts = getopt.getopt(sys.argv[1:], "h", ["help"])[0]
    except getopt.GetoptError, err:
        print str(err) # indicate that the given option is not recognized
        help()
        sys.exit(2)

    for o in opts:
        if o[0] in ("-h", "--help"):
            help()
            sys.exit()
        else:
            assert False, "unhandled option"

    try:
        r = Requirements()
        r.check()
    except Exception, e:
        sys.stdout.write(str(e))
        sys.exit(1)

    sys.exit(0)

if __name__ == "__main__":
    main()

