#!/usr/bin/env python

import datetime

from basesoft.web.contrib.account.models import Account
from basesoft.web.core.util.db import Session
from django.conf import settings

from iqportal.client.test.controllers import FmeTestController
from iqportal.iquest.report.schedule import AggregateResponsesTask
from basesoft.web.contrib.compose.models import ComposeInvitee
from iqportal.iquest.core.models import Survey

# gotta be careful where running this
if settings._wrapped.SETTINGS_MODULE  not in\
['basesoft.settings.stable', 'basesoft.settings.testing', 'basesoft.settings.sandbox']:

    sa_session = Session()
    account = sa_session.query(Account).filter(Account.name=='sysadmin').one()

    test_c = FmeTestController(sa_session, account_id=account.id)

    test_c.populate_fme_domain()

    survey_id = test_c.populate_survey()
    survey = sa_session.query(Survey).filter(Survey.id==survey_id).one()
    test_c.add_weight_factors(survey)
    
    contact_lists = [cl.id for cl in test_c.get_contact_lists(test_c.admin_account)]

    for x in range(3):
        publication_id = test_c.publish_survey(survey_id, label=x, begin_date=datetime.datetime(2013, 1, 1), additional_state={'contact_lists': contact_lists})

        invitees = sa_session.query(ComposeInvitee).filter(ComposeInvitee.publication_id==publication_id).all()
        i = 0
        for invitee in invitees:
            i = i + 1
            test_c.populate_responses(publication_id, seed='bier'*i*x, invitee_hash=invitee.invitee_hash)

    # aggregator
    AggregateResponsesTask().execute()

