#!/usr/bin/env python
'''
Created on Oct 23, 2014

@author: marten
'''

import os, subprocess

from django.conf import settings

from iqportal.iqube import compose
from iqportal.iqube.core import MDX_METHODS, get_properties

if settings.WKHTMLTOIMAGE_BIN is None:
    raise Exception('settings.WKHTMLTOIMAGE_BIN is None')

output_path = os.path.join(os.path.dirname(compose.__file__), 'media/examples/')

def generate_image(c, _type='method'):
    m = c.name
    if c.example_mdx is None:
        print 'No example MDX found for %s (%s), generating empty image' % (_type, m)
    else:
        print 'Generating example for %s (%s)' % (_type, m)

    temp_file = os.path.join(settings.TMP_FILE_REPOSITORY, 'example_%s.png' % m.lower())
    url = 'http://0.0.0.0:8000/iqportal.iqube.test/cubetable/%s/%s/' % (_type, m)

    cmd = [settings.WKHTMLTOIMAGE_BIN,
           "--javascript-delay", "1000",
           #"--debug-javascript",
           "--crop-w", "650",
           url,
           temp_file
    ]

    # spawn the converter process. very important is here not to use shell=True for command injection
    proc = subprocess.Popen(cmd)

    # wait till program is done
    # we dont check for error code because that seems to be unreliable. If the html contains a non existing image (404) or
    # any error code then the wkhtmltopdf returns an error code. Instead just check if it generated any pdf file.
    proc.wait()

    if not os.path.exists(temp_file):
        raise Exception('Failed to create screenshot')

    output_file = os.path.join(output_path, '%s_%s.png' % (_type, m.lower()))

    # move the file to a correct location
    os.rename(temp_file, output_file)

print 'Iterating all available MDX Methods'

# loop all methods and save the screenshot
for m, c in MDX_METHODS.iteritems():
    generate_image(c)

print 'Iterating all available MDX Properties'

for c in get_properties():
    generate_image(c, 'property_%s' % c.category)
