#!/usr/bin/python

"""
This script used by puppet is intended to be run from the installed dirs of all iqportal apps.
For example: /var/www/iqportal-testing.basesoft.com

In there the dirs 'iqportal' en 'pvcycle' are found. It adds these paths to the PYTHONPATH
and then loops all installed apps based on DJANGO_SETTINGS_MODULE and copies their media dir
to the give --target-path
"""


import os
import sys

pythonpath=""
for dir in os.listdir("."):
    if not os.path.isdir(dir):
        continue
    sys.path.append(dir)
sys.path.append("iqportal/related/libs")


from django.conf import settings
from optparse import OptionParser

if __name__ == '__main__':

    parser = OptionParser()
    parser.add_option("--target", dest="target", help="target directory destination")

    (options, args) = parser.parse_args()
    assert options.target is not None
    assert os.path.exists(options.target)

    for app in settings.INSTALLED_APPS:

        module = __import__(app, {}, {}, [''])
        media_path = module.__path__[0] + '/media'

        if not os.path.exists(media_path):
            print 'skipping path %s' % media_path
            continue

        cmd = '/bin/cp -r "%s" "%s/%s"' % (media_path, options.target, app)
        print cmd
        if os.system(cmd) != 0:
            raise Exception('failed to execute: %s' % cmd)

