#! /usr/bin/env python

import os
import tornado.httpserver
import tornado.ioloop
import tornado.wsgi
import sys
import django.core.handlers.wsgi
from django.conf import settings



from sockjs.tornado import SockJSRouter
from basesoft.web.core.connection import IQPortalSockJSConnection

instance = None

def main():
    router = SockJSRouter(IQPortalSockJSConnection, '/sockjs')

    django_app = tornado.wsgi.WSGIContainer(django.core.handlers.wsgi.WSGIHandler())
    sockjs_app = tornado.web.Application(router.urls+[
        ('.*', tornado.web.FallbackHandler, dict(fallback=django_app))
    ], debug=settings.DEBUG)

    http_server = tornado.httpserver.HTTPServer(sockjs_app)
    http_server.listen(8001, "0.0.0.0")

    global instance

    instance = tornado.ioloop.IOLoop.instance()
    instance.start()

if __name__ == "__main__":
    try:
        main()
    except KeyboardInterrupt:

        global instance
        instance.close()
        print 'called close'

        raise
