#!/usr/bin/env python

# Copyright (c) 2010 BaseSoft B.V.
# See LICENSE for details.

import getopt, sys
from basesoft.web.core.management.commands.iqupgradedb import Command

def main():
    try:
        opts = getopt.getopt(sys.argv[1:], "hd", ["help", "no-dryrun"])[0]
    except getopt.GetoptError, err:
        print str(err) # will print something like "option -a not recognized"
        sys.exit(2)

    c = Command()

    if len(opts)==0:
        c.handle(dryrun=True)

    for o in opts:
        if o[0] in ("-h", "--help"):
            print 'use --no-dryrun to disable dry run'
            sys.exit()
        if o[0] in ("-d", "--no-dryrun"):
            c.handle(dryrun=False)

if __name__ == "__main__":
    main()
