# Copyright (c) 2008 BaseSoft B.V.
# See LICENSE for details.

from basesoft.settings.buildbot import *
from selenium.webdriver.common.desired_capabilities import DesiredCapabilities

DB_CONNSTR = 'mysql://buildbot_ie:buildbot@testorix.dev.ams:3306/iqportal_buildbot_ie?charset=utf8'
DB_CONNSTR_READONLY = 'mysql://buildbot_ie_ro:buildbot@testorix.dev.ams:3306/iqportal_buildbot_ie?charset=utf8'
DB_CONNSTR_FOODMART = 'mysql://foodmart:foodmart@testorix.dev.ams:3306/foodmart?charset=utf8'

# send to vm.office selenium hub
SELENIUM['host'] = 'vm.office'
SELENIUM['port'] = '4444'
SELENIUM['desired_capabilities'] = DesiredCapabilities.INTERNETEXPLORER

SELENIUM['browserStartCommand'] = '*iexplore'
SELENIUM['screenshot_path'] = '/var/lib/buildbot/public_html/screenshots/iqportal_ie'

# ie runs on port 8002
SELENIUM['browserURL']  = 'http://testorix.dev.ams.basesoft.com:8002/'
SELENIUM_DJANGO_ADDR = '0.0.0.0:8002'

SCHEDULER_SERVER_PORT = 8042
SCHEDULER_SERVER_XMLRPC = 'http://localhost:8042/'

# debug log to file
from logging import FileHandler
logger = logging.getLogger()
logger.addHandler(FileHandler('/tmp/iqportal_basesoft.settings.buildbot_ie.log'))

VIRTUAL_DATE = '/tmp/buildbot_virtual_date_ie.txt'

