# Copyright (c) 2008 BaseSoft B.V.
# See LICENSE for details.

"""
Settings for the IQPortal Django project
"""

import time, commands
from basesoft.settings.debug import *
from selenium.webdriver.common.desired_capabilities import DesiredCapabilities
from os import makedirs

DEBUG = True
TEMPLATE_DEBUG = DEBUG

YUI_DEBUG_FILES = True
USE_SOCK_JS = False

BASE_URL = 'http://192.168.8.75:8000/'

#DATABASE_ENGINE = ''           # 'postgresql_psycopg2', 'postgresql', 'mysql', 'sqlite3' or 'oracle'.
#DATABASE_NAME = ''             # Or path to database file if using sqlite3.
#DATABASE_USER = ''             # Not used with sqlite3.
#DATABASE_PASSWORD = ''         # Not used with sqlite3.
#DATABASE_HOST = ''             # Set to empty string for localhost. Not used with sqlite3.
#DATABASE_PORT = ''             # Set to empty string for default. Not used with sqlite3.

#SCHEDULER_TWISTD = '/opt/local/bin/twistd-2.6'

DB_CONNSTR = 'mysql://root:root@localhost:3306/iqportal?charset=utf8'
#DB_CONNSTR = 'mysql://root:basesoft@marten.dev.ams:3306/iqportal'
DB_CONNSTR_FOODMART = 'mysql://foodmart:foodmart@testorix.dev.ams:3306/foodmart?charset=utf8'
#DB_CONNSTR_WEEEBLACKBOX = 'mysql://root:basesoft@127.0.0.1:3306/IQ_ELC_MARTEN_STBL'

DB_CONNSTR_READONLY = DB_CONNSTR


LUCIDDB_URL = "jdbc:luciddb:http://192.168.8.10"

LUCIDDB_USERNAME = "sa"
LUCIDDB_PASSWORD = ""
LUCIDDB_DATASOURCE_PROTOCOL = "luciddb"
LUCIDDB_DATASOURCE_HOST = "nestorix.office.basesoft.com"
LUCIDDB_DATASOURCE_PORT = "8034"

LUCIDDB_PG2_CONNSTR = "host='192.168.8.10' port=8035 dbname='LOCALDB' user='sa' password=''"

LUCIDDB_SCHEMA_PREFIX = 'IAN_'

# used for conversion tool testing
#DB_PHP4_IQUEST = {'user': 'root', 'password': 'basesoft', 'host': '127.0.0.1', 'db': 'IS_FMEGTA_EDIT'}

'''
MONDRIAN_XMLA_SERVER = ('localhost', 8080)
IQUBE_SERVLET = "http://localhost:8080/iqube-ian/IQubeXmlRpcServlet"
MONDRIAN_XMLA_PATH = '/iqube-ian/xmla'
'''

MONDRIAN_XMLA_SERVER = ('localhost', 8080)

mondrian_eclipse = False

if mondrian_eclipse:
    IQUBE_SERVLET = "http://localhost:8080/iqube/IQubeXmlRpcServlet"
    MONDRIAN_XMLA_PATH = '/iqube/xmla'
else:
    IQUBE_SERVLET = "http://localhost:8080/iqube-ian/IQubeXmlRpcServlet"
    MONDRIAN_XMLA_PATH = '/iqube-ian/xmla'

MONDRIAN_XMLA_CACHE_ENABLED = False

EMAIL_HOST = 'localhost'

# function to generate selenium object to be used to start selenium / unit testing
def selenium_start(local=False, browser=None, start_django=False, start_scheduler=False, remote=False):
    SELENIUM = {}
    SELENIUM['closeBrowser'] = False

    if local is True:
        SELENIUM['host'] = '0.0.0.0'
        SELENIUM['browserURL']  = 'http://0.0.0.0:8000/'
    else:
        SELENIUM['host'] = '192.168.8.236'
        SELENIUM['browserURL']  = 'http://192.168.8.75:8000/'

    SELENIUM['port'] = '4444'
    SELENIUM['timeout'] = 10 * 60 * 1000
    SELENIUM['screenshot_path'] = '/tmp/'
    SELENIUM['assertClean'] = False

    if start_scheduler is True:
        SCHEDULER_SERVER_PORT = 8044
        SCHEDULER_SERVER_XMLRPC = 'http://0.0.0.0:8044/'

    if browser == 'ff':
        start_browser = DesiredCapabilities.FIREFOX
    elif browser == 'ie':
        if local is False:
            start_browser = DesiredCapabilities.INTERNETEXPLORER # start internet explorer
        else:
            print "There is no IE for linux, running Firefox instead ... "
            time.sleep(1)
            start_browser = DesiredCapabilities.FIREFOX # start firefox
    elif browser == 'gc':
        start_browser = DesiredCapabilities.CHROME
    else:
        start_browser = DesiredCapabilities.FIREFOX

    SELENIUM['desired_capabilities'] = start_browser
    SELENIUM['maximize_window'] = False
    SELENIUM['start_django'] = start_django
    SELENIUM['start_scheduler'] = start_scheduler

    return SELENIUM

'''
Call function to start selenium test

local: [True|False]
    True    : start selenium test on local machine
    False   : start selenium test on VM

Browser: [ff|ie|gc]
    ff : use firefox browser
    ie : use internet explorer browser (only available if local is set to VM)
    gc : use chrome browser

start_django: [True|False]
    True : start django with start of test
    False : start without django

start_scheduler: [True|False]
    True : start scheduler
    False : no scheduler

remote: [True|False]
    True : start remote test on buildbot machine
    False : no remote test on buildbot machine

SELENIUM = selenium_start(local, browser, start_django, start_scheduler, remote)
'''
SELENIUM = selenium_start(local=True, browser='gc', start_django=False, start_scheduler=False, remote=False)

SERVE_STATIC_MEDIA = True

INSTALLED_APPS = BASE_APPS + CLIENT_APPS + IQUBE_APPS + IQREPORT_APPS + IQUEST_APPS + TNT_APPS
add_test_apps(INSTALLED_APPS)

STATIC_SQUASHED_ROOT = '/home/ian/static'

WRITABLE_DIRECTORY = '/home/ian/writable/iqportal/'
IQREPORT_GRAPH_LOCATION = WRITABLE_DIRECTORY
FILE_REPOSITORY = WRITABLE_DIRECTORY
CACHE_DIR = os.path.join(WRITABLE_DIRECTORY, 'cache/')
CONTACT_IMPORT_DIR = os.path.join(WRITABLE_DIRECTORY, 'contacts/')

# Allow any remote addr to be in admin ips
MIDDLEWARE_CLASSES.append('basesoft.web.middleware.dev.RemoteAddrToInternalIp')
#NODEJS_SERVER = 'http://192.168.8.127:8081'

#WKHTMLTOPDF_BIN = "/Applications/wkhtmltopdf/Contents/MacOS/wkhtmltopdf"

# careful with this dir as files get deleted after 24h by the scheduler
TMP_FILE_REPOSITORY = '/home/ian/writable/iqportal/temp'

# this is needed for the ticketing app
TRAC_CONNSTR = 'http://IQPortal:m8metrU3@trac.iqportal.basesoft.com/login/xmlrpc'
TRAC_IQPORTAL_VERSION = 'stable'
TRAC_DB_CONNSTR = 'mysql://trac:tePRedutha2a@db.clusternet:3306/trac_iqportal?charset=utf8'

TEMPURA = 'RaKa4Rucru8r'

SITE_NAME = False

# below is for running the tests from eclipse
if __name__ == '__main__':

    from twisted.scripts.trial import run
    import sys
    import os
    os.environ['DJANGO_SETTINGS_MODULE'] = 'basesoft.settings.ian'
    sys.argv = ['test_case.py', 'iqportal.iqube.test.selenium.test_result_item']
    run()
    sys.exit()
