# Copyright (c) 2008 BaseSoft B.V.
# See LICENSE for details.

"""
Settings for the IQPortal Django project
"""
from basesoft.settings.debug import *
from selenium.webdriver.common.desired_capabilities import DesiredCapabilities

DEBUG = True
TEMPLATE_DEBUG = DEBUG

TMP_FILE_REPOSITORY = '/Users/marten/writable'

YUI_DEBUG_FILES = True

BASE_URL = 'http://192.168.8.78:8000/'

#DATABASE_ENGINE = ''           # 'postgresql_psycopg2', 'postgresql', 'mysql', 'sqlite3' or 'oracle'.
#DATABASE_NAME = ''             # Or path to database file if using sqlite3.
#DATABASE_USER = ''             # Not used with sqlite3.
#DATABASE_PASSWORD = ''         # Not used with sqlite3.
#DATABASE_HOST = ''             # Set to empty string for localhost. Not used with sqlite3.
#DATABASE_PORT = ''             # Set to empty string for default. Not used with sqlite3.

SCHEDULER_TWISTD = '/opt/local/bin/twistd-2.6'

DB_CONNSTR = 'mysql://iqportal:basesoft@192.168.8.78:3306/iqportal?charset=utf8'
#DB_CONNSTR = 'mysql://root:basesoft@marten.dev.ams:3306/iqportal'
DB_CONNSTR_FOODMART = 'mysql://foodmart:foodmart@virtualix.office.basesoft.com:3306/foodmart'
#DB_CONNSTR_WEEEBLACKBOX = 'mysql://root:basesoft@127.0.0.1:3306/IQ_ELC_MARTEN_STBL'

DB_CONNSTR_READONLY = 'mysql://iqportal_ro:basesoft@192.168.8.78:3306/iqportal?charset=utf8'


LUCIDDB_URL = "jdbc:luciddb:http://192.168.8.10"

LUCIDDB_USERNAME = "sa"
LUCIDDB_PASSWORD = ""
LUCIDDB_DATASOURCE_PROTOCOL = "luciddb"
LUCIDDB_DATASOURCE_HOST = "nestorix.office.basesoft.com"
LUCIDDB_DATASOURCE_PORT = "8034"

LUCIDDB_PG2_CONNSTR = "host='192.168.8.10' port=8035 dbname='LOCALDB' user='sa' password=''"

LUCIDDB_SCHEMA_PREFIX = 'MARTEN_'


SELENIUM_MAC = {}
SELENIUM_MAC['closeBrowser'] = False
SELENIUM_MAC['host'] = '192.168.8.78'
SELENIUM_MAC['browserURL']  = 'http://192.168.8.78:8000/'
SELENIUM_MAC['port'] = '4444'
SELENIUM_MAC['timeout'] = 10 * 60 * 1000
SELENIUM_MAC['screenshot_path'] = '/tmp/'
SELENIUM_MAC['assertClean'] = False
SELENIUM_MAC['desired_capabilities'] = DesiredCapabilities.CHROME
SELENIUM_MAC['maximize_window'] = True

SELENIUM_DJANGO_ADDR = '0.0.0.0:8000'

SELENIUM_WIN = {}
SELENIUM_WIN['closeBrowser'] = False
SELENIUM_WIN['host'] = 'vm-win7.office.basesoft.com'
SELENIUM_WIN['browserURL']  = 'http://192.168.8.78:8000/'
SELENIUM_WIN['port'] = '4444'
SELENIUM_WIN['timeout'] = 10 * 60 * 1000
SELENIUM_WIN['screenshot_path'] = '/tmp/'
SELENIUM_WIN['assertClean'] = False
SELENIUM_WIN['desired_capabilities'] = DesiredCapabilities.INTERNETEXPLORER
SELENIUM_WIN['maximize_window'] = True

SELENIUM_WIN_LOCAL = {}
SELENIUM_WIN_LOCAL['closeBrowser'] = True
SELENIUM_WIN_LOCAL['host'] = '192.168.8.249'
SELENIUM_WIN_LOCAL['browserURL']  = 'http://192.168.8.78:8000/'
SELENIUM_WIN_LOCAL['port'] = '4444'
SELENIUM_WIN_LOCAL['timeout'] = 10 * 60 * 1000
SELENIUM_WIN_LOCAL['screenshot_path'] = '/tmp/'
SELENIUM_WIN_LOCAL['assertClean'] = False
SELENIUM_WIN_LOCAL['desired_capabilities'] = DesiredCapabilities.INTERNETEXPLORER
SELENIUM_WIN_LOCAL['maximize_window'] = True

SELENIUM = SELENIUM_MAC
SELENIUM['start_django'] = True
SELENIUM['start_scheduler'] = True

# used for conversion tool testing
#DB_PHP4_IQUEST = {'user': 'root', 'password': 'basesoft', 'host': '127.0.0.1', 'db': 'IS_FMEGTA_EDIT'}

MONDRIAN_XMLA_SERVER = ('192.168.8.78', 8080)
MONDRIAN_XMLA_PATH = '/iqube/xmla'
IQUBE_SERVLET = "http://192.168.8.78:8080/iqube/IQubeXmlRpcServlet"

MONDRIAN_XMLA_CACHE_ENABLED = False

EMAIL_HOST = 'vm.office'

TRAC_CONNSTR = 'http://Marten Koedam:mi3!OA@trac.office.basesoft.com/trac-sandbox/login/xmlrpc'
TRAC_IQPORTAL_VERSION = 'marten'
TRAC_DB_CONNSTR = 'mysql://trac:trac@vm.office:3306/trac_sandbox?charset=utf8'
#TRAC_EXTERNAL_URL = 'http://mac-marten.dev.ams:8000/'

SERVE_STATIC_MEDIA = True

INSTALLED_APPS = BASE_APPS + CLIENT_APPS + IQUBE_APPS + IQREPORT_APPS + IQUEST_APPS + TNT_APPS
#INSTALLED_APPS = BASE_APPS + CLIENT_APPS + IQUBE_APPS + IQREPORT_APPS
add_test_apps(INSTALLED_APPS)

# Allow any remote addr to be in admin ips
MIDDLEWARE_CLASSES.append('basesoft.web.middleware.dev.RemoteAddrToInternalIp')

WKHTMLTOPDF_BIN = "/Applications/wkhtmltopdf.app/Contents/MacOS/wkhtmltopdf"
WKHTMLTOIMAGE_BIN = "/Users/marten/Desktop/wkhtmltoimage"

import os
if os.uname()[0] == 'Darwin':
    FONTS_PATH = None#'/Users/marten/workspace/fonts/'
    LOGGER_SYSLOG_ADDRESS = '/var/run/syslog'

ORDER_OGONE_POST = "%sbasesoft.web.test/selenium/order/ogone_payment_accept/" % BASE_URL

# below is for running the tests from eclipse
if __name__ == '__main__':

    from twisted.scripts.trial import run
    import sys
    sys.argv = ['test_bier.py', 'iqportal.iqube.test.unit.test_compose.TestCase.test_save_simple_named_set']
    #sys.argv = ['test_bier.py', 'iqportal.iqube.test.selenium.test_optiq.TestCase']
    run()
    sys.exit()
