# Copyright (c) 2008 BaseSoft B.V.
# See LICENSE for details.

"""
martijn settings
"""

import os
import sys
import commands

from basesoft.settings.debug import *
from selenium.webdriver.common.desired_capabilities import DesiredCapabilities
from os import makedirs

SYSLOG_IDENT = 'iqportal-martijn'

DEBUG = True
SYSLOG_IDENT = 'iqportal-martijn'

YUI_DEBUG_FILES = True
ADMINS = (('Tek', 'martijn@basesoft.com'), )

# base url
BASE_URL = 'http://martijn-i7.dev.bcn.basesoft.com:8000/'

DB_CONNSTR = 'mysql://root:f00b4r@martijn-i7.dev.bcn:3306/iqportal?charset=utf8'
DB_CONNSTR_READONLY = 'mysql://root_ro:f00b4r@martijn-i7.dev.bcn:3306/iqportal?charset=utf8'
DB_CONNSTR_FOODMART = 'mysql://root:f00b4r@martijn-i7.dev.bcn:3306/foodmart?charset=utf8'

FONTS_PATH = None

if commands.getoutput('hostname') == 'virtualix':
    BASE_URL = 'http://vm.office:8000/'
    DB_CONNSTR = DB_CONNSTR_READONLY= 'mysql://martijn:f00b4r@127.0.0.1:3306/iqportal_martijn?charset=utf8'
    DB_CONNSTR_FOODMART = 'mysql://foodmart:foodmart@testorix.dev.ams:3306/foodmart?charset=utf8'
    #FONTS_PATH = None

SELENIUM_DEFAULT = {}
SELENIUM_DEFAULT['closeBrowser'] = False
SELENIUM_DEFAULT['port'] = '4444'

SELENIUM_DEFAULT['timeout'] = 20 * 1000
SELENIUM_DEFAULT['screenshot_path'] = '/tmp/iqportal/'
#SELENIUM_DEFAULT['desired_capabilities'] = DesiredCapabilities.FIREFOX
SELENIUM_DEFAULT['desired_capabilities'] = DesiredCapabilities.CHROME
#SELENIUM_DEFAULT['desired_capabilities']['chrome.binary'] = '/usr/bin/chromium-browser --allow-no-sandbox-job'
#SELENIUM_DEFAULT['desired_capabilities']['nativeEvents'] = True
SELENIUM_DEFAULT['maximize_window'] = True
SELENIUM_DEFAULT['assertClean'] = False
SELENIUM_DEFAULT['start_django'] = False
SELENIUM_DEFAULT['start_scheduler'] = False


SELENIUM_LOCAL = SELENIUM_DEFAULT.copy()
SELENIUM_LOCAL['host'] = '0.0.0.0'
#SELENIUM_LOCAL['browserURL']  = BASE_URL
#SELENIUM_LOCAL['desired_capabilities'] = DesiredCapabilities.FIREFOX
SELENIUM_LOCAL['desired_capabilities'] = DesiredCapabilities.CHROME
SELENIUM_LOCAL['browserURL']  = 'http://192.168.16.26:8000/'

SELENIUM_VM = SELENIUM_DEFAULT.copy()
SELENIUM_VM['host'] = '192.168.16.135'
SELENIUM_VM['browserURL']  = 'http://192.168.16.26:8000/'
#SELENIUM_VM['desired_capabilities'] = DesiredCapabilities.INTERNETEXPLORER
SELENIUM_VM['desired_capabilities'] = DesiredCapabilities.CHROME
#SELENIUM_VM['desired_capabilities'] = DesiredCapabilities.FIREFOX

SELENIUM_BB = SELENIUM_DEFAULT.copy()
SELENIUM_BB['host'] = 'vm.office'
SELENIUM_BB['browserURL']  = 'http://martijn-i7.dev.bcn.basesoft.com:8000/'
SELENIUM_BB['desired_capabilities'] = DesiredCapabilities.CHROME
SELENIUM_BB['platform'] = 'LINUX'

SELENIUM_VX = SELENIUM_DEFAULT.copy()
SELENIUM_VX['host'] = 'vm.office'
SELENIUM_VX['port'] = '4445'
SELENIUM_VX['browserURL']  = 'http://vm.office:8000/'
SELENIUM_VX['desired_capabilities'] = DesiredCapabilities.CHROME
SELENIUM_VX['platform'] = 'LINUX'

SELENIUM = SELENIUM_VX

# buildbot
if False:
    SELENIUM['host'] = 'martijn.dev.ams'
    SELENIUM['port'] = '4446'


SELENIUM_DJANGO_ADDR = '0.0.0.0:8000'

# custom log levels
#logging.getLogger('iqportal.iquest.schedule').setLevel(logging.DEBUG)
#logging.getLogger('iqportal.iquest.response').setLevel(logging.DEBUG)

# smtp basesoft-fs
EMAIL_HOST = '192.168.8.20'

#
# IQube server settings
#

mondrian_eclipse = False

if mondrian_eclipse:

    port = 8080 if not commands.getoutput('hostname') == 'virtualix' else 8081

    MONDRIAN_XMLA_SERVER = ('localhost', port)
    IQUBE_SERVLET = "http://localhost:%s/iqube/IQubeXmlRpcServlet" % port
    MONDRIAN_XMLA_PATH = '/iqube/xmla'
else:
    MONDRIAN_XMLA_SERVER = ('localhost', 8080)
    IQUBE_SERVLET = "http://localhost:8080/iqube-martijn/IQubeXmlRpcServlet"
    MONDRIAN_XMLA_PATH = '/iqube-martijn/xmla'


if os.uname()[0] == 'Darwin':
#    FONTS_PATH = '/Users/martijn/gentoo/usr/share/fonts/'
    FONTS_PATH = None
    JS_LINT_BIN='/Users/martijn/src/jsl-0.3.0-mac/jsl'

if commands.getoutput('hostname') == 'martijn-i7':

    FONTS_PATH = None
    #FONTS_PATH = '/usr/share/fonts/truetype/'


#PROFILING = True

# SCHEDULER_TASKS_ENABLED = False

INSTALLED_APPS = BASE_APPS + CLIENT_APPS + IQUBE_APPS + IQREPORT_APPS + IQUEST_APPS
add_test_apps(INSTALLED_APPS)


MONDRIAN_XMLA_CACHE_ENABLED = True
#GRAPH_CACHE_ENABLED = True

#WKHTMLTOPDF_BIN = "/home/martijn/src/wkhtmltox/wkhtmltopdf-amd64"
WKHTMLTOPDF_BIN = "/usr/bin/wkhtmltopdf"


#SCHEDULER_SERVER_PORT = 8044
#SCHEDULER_SERVER_XMLRPC = 'http://0.0.0.0:8044/'

#TRIAL_REPORT_URL = ('127.0.0.1:8053', '/buildbot/submit/')

#SESSION_COOKIE_AGE = 60 * 5
#KEEP_SIGNED_COOKIE_AGE = 1612800

#REDIS_HOST = '127.0.0.1'

# check if temp is writable
if commands.getoutput('hostname') == 'virtualix':
    WRITABLE_DIRECTORY = '/home/martijn/workspace/iqportal/writable'
    TMP_FILE_REPOSITORY = os.path.join(WRITABLE_DIRECTORY, 'temp')
    if not os.path.exists(TMP_FILE_REPOSITORY):
        makedirs(TMP_FILE_REPOSITORY)
    assert os.access(TMP_FILE_REPOSITORY, os.W_OK)

#MONDRIAN_INSTANCE = 'bieryo'

#SCHEDULER_SERVER_PORT = 9340

ORDER_OGONE_POST = "%sbasesoft.web.test/selenium/order/ogone_payment_accept/" % BASE_URL

#VIRTUAL_DATE=None

CPDB_DOMAIN_HOSTS = {
    'Testing': 'martijn.com'
}



# below is for running the tests from eclipse
if __name__ == '__main__':

    from twisted.scripts.trial import run
    import sys
    os.environ['DJANGO_SETTINGS_MODULE'] = 'basesoft.settings.martijn'
    sys.argv = ['test_bier.py', 'iqportal.iquest.test.selenium.test_iquest_report.TestCase.test_multi_qa_item']
    run()
    sys.exit()
