# Copyright (c) 2008 BaseSoft B.V.
# See LICENSE for details.

# Django settings for iqreport project.

import os

DEBUG = False
TEMPLATE_DEBUG = False

# form validation can be turned off by setting this to FALSE
FORM_VALIDATION = True

# defines using -debug or -min files
YUI_DEBUG_FILES = False

LOADER_REDIRECT = True

# send error emails to tek
ADMINS = (('Tek', 'servers@mail.clusternet'), )

# Leave internal ips empty! place them in your local settings
INTERNAL_IPS = ()

# sqlalchemy db connstr
DB_CONNSTR = ''
DB_CONNSTR_READONLY = ''

# Local time zone for this installation. Choices can be found here:
# http://en.wikipedia.org/wiki/List_of_tz_zones_by_name
# although not all choices may be available on all operating systems.
# If running in a Windows environment this must be set to the same as your
# system time zone.
TIME_ZONE = 'Europe/Amsterdam'

# Language code for this installation. All choices can be found here:
# http://www.i18nguy.com/unicode/language-identifiers.html
LANGUAGE_CODE = 'en'

# whats this for?
SITE_ID = 1

# If you set this to False, Django will make some optimizations so as not
# to load the internationalization machinery.
USE_I18N = True
USE_L10N = True

# Only languages listed in the LANGUAGES setting can be selected.
# see http://www.djangobook.com/en/1.0/chapter18/
_ = lambda s: s
LANGUAGES = (
    ('en', _('English')),
    ('nl', _('Dutch')),
    ('de', _('German')),
    ('it', _('Italian')),
    ('fr', _('French')),
    ('es', _('Spanish')),
    ('zh-cn', _('Chinese')),
)

# Absolute path to the directory that holds media.
# Example: "/home/media/media.lawrence.com/"
#import iqportal
#MEDIA_ROOT = iqportal.__path__[0] + '/'

# static root contains squashed files for caching
import iqportal
STATIC_SQUASHED_ROOT = iqportal.__path__[0] + '/../static'
STATIC_MEDIA_ROOT = os.path.join(iqportal.__path__[0], '../../site_media')

# controls if /urls.py should handle media files.
# enable this when developing
SERVE_STATIC_MEDIA = False

# URL that handles the media served from MEDIA_ROOT. Make sure to use a
# trailing slash if there is a path component (optional in other cases).
# Examples: "http://media.lawrence.com", "http://example.com/media/"
#MEDIA_URL = '/site_media/'

# Make this unique, and don't share it with anybody.
SECRET_KEY = 'wl88il)pbx4d6h8wwvfb02!w8u9-cmu%#uo2bidx5paehha4*5'


MIDDLEWARE_CLASSES = [
    'basesoft.web.middleware.profile.ProfileMiddleware',
    'basesoft.web.middleware.db.SAEngineMiddleware',
    'basesoft.web.contrib.session.middleware.SASessionMiddleware',
    #'django.middleware.locale.LocaleMiddleware',
    'basesoft.web.middleware.locale.LocaleMiddleware',
    'django.middleware.common.CommonMiddleware',
    'django.contrib.auth.middleware.AuthenticationMiddleware',
    'django.middleware.doc.XViewMiddleware',
    'basesoft.web.middleware.location.DefaultLocation',
    'basesoft.web.middleware.exception.ExceptionMiddleware',
]

ROOT_URLCONF = 'basesoft.urls'

TEMPLATE_DIRS = (
    # Always use forward slashes, even on Windows.
    # Don't forget to use absolute paths, not relative paths.
)

from django.core import management

BASE_APPS = [
    'django.contrib.auth',
    'django.contrib.contenttypes',
    'django.contrib.sites',

    'basesoft.web.core',

    'basesoft.web.contrib.dashboard',
    'basesoft.web.dev',
    'basesoft.web.dev.compose',
    'basesoft.web.dev.util',

    'basesoft.web.contrib.jquery',

    'basesoft.web.contrib.session',
    'basesoft.web.contrib.i18n',
    'basesoft.web.contrib.yui',
    'basesoft.web.contrib.wireit',

    'basesoft.web.contrib.animate',

    'basesoft.web.contrib.fusioncharts',

    'basesoft.web.contrib.file',
    'basesoft.web.contrib.contact',
    'basesoft.web.contrib.license',
    'basesoft.web.contrib.mailing',
    'basesoft.web.contrib.manual',
    'basesoft.web.contrib.account',
    'basesoft.web.contrib.excanvas',
    'basesoft.web.contrib.notification',
    'basesoft.web.contrib.graph',
    'basesoft.web.contrib.compose',
    'basesoft.web.contrib.order',
    'basesoft.web.contrib.soap',
    'basesoft.web.contrib.lib',

    'basesoft.web.contrib.basesoft',
    'basesoft.web.contrib.branding',
    'basesoft.web.contrib.theme',
    'basesoft.web.contrib.ticketing',

    'basesoft.web.contrib.wiki',
    'basesoft.web.contrib.announce',

    # website app not finished: #417
    # 'iqportal.website',
    'basesoft.web.contrib.scheduler',

    'basesoft.web.contrib.home',



    'basesoft.web.mobile',

]

IQREPORT_APPS = [
    'iqportal.iqreport.core',
    'iqportal.iqreport.compose',
    'iqportal.iqreport.display',
]

IQUEST_APPS = [
    'iqportal.iquest.core',
    'iqportal.iquest.compose',
    'iqportal.iquest.response',
    'iqportal.iquest.export',
    'iqportal.iquest.report',
    'iqportal.iquest.mobile',
]

TNT_APPS = [
    'iqportal.tnt.core',
    'iqportal.tnt.clm',
    'iqportal.tnt.response',
    'iqportal.tnt.report',
    'iqportal.tnt.sr', # TODO: move to test only.
]

IQUBE_APPS = [
    'iqportal.iqube.core',
    'iqportal.iqube.compose',
    'iqportal.iqube.optiq',
    'iqportal.iqube.xmla',
]

MISC_APPS = [
]

XBRL_APPS = [
    'iqportal.xbrl.core',
    'iqportal.xbrl.report'
]

SAP_APPS = [
    'iqportal.sap.core',
    'iqportal.sap.report',
]

DEMO_APPS = [
    'iqportal.demo.core',
    'iqportal.demo.mobile',
]
CLIENT_APPS = [
    'iqportal.client.core',
    'iqportal.client.arvato',
]

UAT_APPS = [
    'basesoft.web.contrib.uat'
]

INSTALLED_APPS = BASE_APPS + IQUBE_APPS + IQREPORT_APPS + IQUEST_APPS + TNT_APPS + CLIENT_APPS

#
# Template processors can add django variables to the templates
# IMPORTANT: to make this work you have to pass
# 'context_instance=RequestContext(request))' into render_to_response().

TEMPLATE_CONTEXT_PROCESSORS = (
    "django.contrib.auth.context_processors.auth",
    #"django.core.context_processors.i18n",
    "django.core.context_processors.media",

    "basesoft.web.core.context_processors.i18n",
    "basesoft.web.core.context_processors.debug",
    "basesoft.web.core.context_processors.auth",
    "basesoft.web.core.context_processors.extras",
)

# Point this to where locales are stored
#LOCALE_PATHS = ('/path/to/iqportal.iqreport/locale', )

# the number of days activation keys will remain valid after they were created
ACTIVATION_KEY_VALID_DAYS = 30

# Email configuration settings used in mailing application
EMAIL_HOST = 'localhost'
EMAIL_PORT = '25'
EMAIL_FROM = '"IQPortal Technologies, BaseSoft B.V." <noreply@iqportalmail.com>'

EMAIL_FROM_TNT = 'tnt@iqportalmail.com'
EMAIL_HOST_TNT = EMAIL_HOST
EMAIL_PORT_TNT = EMAIL_PORT

# TNT url for invitees, if None, it uses base-url
TNT_EMAIL_URL_FOR_INVITEES = None

# whats this
LOGIN_URL = '/basesoft.web.contrib.account/login'
LOGIN_REDIRECT_URL = '/'
LOGOUT_REDIRECT_URL = '/'

USE_SOCK_JS = False
#
# Python Logging
# The logger is created in our own basesoft.logging package.. import it from there
#
import logging
LOGGER_SYSLOG_ADDRESS = ('localhost', 514)
LOGGER_STDOUT_LEVEL = logging.INFO
LOGGER_SYSLOG_LEVEL = logging.INFO

#
# Mondrian
#

# name of the webapp
MONDRIAN_INSTANCE = 'iqube-testing'

# where can the mondrian server be found
MONDRIAN_XMLA_SERVER = ('localhost', 8080)

# where to execute xmla queries against
MONDRIAN_XMLA_PATH = '/iqube-testing/xmla'

# if mondrian responses are cached
MONDRIAN_XMLA_CACHE_ENABLED = True

# if graph image data is cached
GRAPH_CACHE_ENABLED = True

# IQUBE_SERVLET used to be http://localhost:8080/iqube-testing/IQubeXmlRpcServlet"
IQUBE_SERVLET = None

# used for conversion tool testing
DB_PHP4_IQUEST = None

# BASE_URL is the http:// root address for the running instance. (ending with slash!)
# This should be overridden in specific site settings.
BASE_URL = 'http://localhost/';

# Trac DB connstr to make custom datasource for searchable overviews
TRAC_DB_CONNSTR = None
TRAC_IQPORTAL_VERSION = None
TRAC_EXTERNAL_URL = None

# scheduler server settings
SCHEDULER_SERVER_PORT = 8040
SCHEDULER_SERVER_XMLRPC = 'http://localhost:8040/'
SCHEDULER_TWISTD = '/usr/bin/twistd'
SCHEDULER_TASKS_ENABLED = True

JS_LINT_BIN = '/usr/bin/jsl'

WRITABLE_DIRECTORY = '/tmp/iqportal/'
IQREPORT_GRAPH_LOCATION = WRITABLE_DIRECTORY
FILE_REPOSITORY = WRITABLE_DIRECTORY
CACHE_DIR = os.path.join(WRITABLE_DIRECTORY, 'cache/')
CONTACT_IMPORT_DIR = os.path.join(WRITABLE_DIRECTORY, 'contacts/')

# careful with this dir as files get deleted after 24h by the scheduler
TMP_FILE_REPOSITORY = '/tmp/iqportal/temp'

FONTS_PATH = '/usr/share/fonts/'

# Google Analytics id. None for disabled. if id is not None, the code for tracking is used.
# id should be in the standard UA-XXXXXXX-YY form. eg: UA-3881234-5
GOOGLE_ANALYTICS_ID = None

# session lifetime (seconds). default 30 minutes, unless the user wants to stay logged in
SESSION_COOKIE_AGE = 2400 # 40 minutes (we leave a margin of 25% for the 30 minutes)

# age for the cookies if the user wants to be kept signed in (the default value Django originally used)
KEEP_SIGNED_COOKIE_AGE = 1612800 # 2 weeks + 25%

# how long after a session is expired should it be removed from the database.
EXPIRED_SESSION_REMOVAL_AGE = 1209600 # 2 weeks

# lifetime for the activity period (minutes). after this period passes and the session has not been updated (eg. when
# the user logs in and closes the tab -> keepalive can't ping) we can safely log in from somewhere else without
# being denied login because we were logged in somewhere else
ACTIVITIY_TIMEOUT = 30

# when enabled it writes profiling output to /tmp/iqportal_profile
PROFILING = False

# ident message for syslog
SYSLOG_IDENT = 'iqportal'

# current iqportal version. this gets replaced by the build_deb.sh to the current tag
VERSION = '1.0.1'

# for pdf printing
WKHTMLTOPDF_BIN = "/usr/bin/wkhtmltopdf"
# for screenshots
WKHTMLTOIMAGE_BIN = None#"/usr/bin/wkhtmltoimage"

# For luciddb
LUCIDDB_URL = "jdbc:luciddb:http://localhost"
LUCIDDB_USERNAME = "sa"
LUCIDDB_PASSWORD = ""
LUCIDDB_DATASOURCE_PROTOCOL = "luciddb"
LUCIDDB_DATASOURCE_HOST = "localhost"
LUCIDDB_DATASOURCE_PORT = "8034"
LUCIDDB_SCHEMA_PREFIX = ''

# this is the luciddb proxy connstr
LUCIDDB_PG2_CONNSTR = "host='localhost' port=8035 dbname='LOCALDB' user='sa' password=''"

# time in seconds before logging chart generation settings
SLOW_CHART_TIME = 5

TRIAL_REPORT_URL = None

IQPORTAL_SERVER_PORT = 9661
SERVER_VERSION = 0.1

# settings for redis. If REDIS_HOST is None it wont be used
REDIS_HOST = None
REDIS_PORT = 6379
REDIS_DB = 0
REDIS_PREFIX = ''
REDIS_PASSWORD = None
REDIS_UNIX_DOMAIN_SOCKET_PATH = None
REDIS_URL = None

# virtual date can link to file
VIRTUAL_DATE = None

SITE_OWNER_LICENSE_NAME = 'BaseSoft Solutions B.V.'
#
# Arvato client settings
#

# location where xml files will be copied to, before they are converted to .csv
ARVATO_LOCAL_PATH = os.path.join(TMP_FILE_REPOSITORY, 'arvato')

# command to move the xml files. this is set to the test arvato_ftp dit and overriden in stable.py to retrieve from asus ftp
# this command must move the files
ARVATO_GET_XML_CMD = 'mv %s/*.xml %s' % (os.path.join(TMP_FILE_REPOSITORY, 'arvato_ftp'), ARVATO_LOCAL_PATH)

# used to allocate the license-id for importing
ARVATO_LICENSE_NAME = 'IQPortal Test License'

# post_action should be set in settings, when BASE_URL is not localhost:
#ORDER_OGONE_POST = "%sbasesoft.web.test/selenium/order/ogone_payment_accept/" % BASE_URL
ORDER_OGONE_POST = None
