# Copyright (c) 2011 BaseSoft B.V.
# See LICENSE for details.

"""
Methods for manipulating images
"""

from django.http import HttpResponse

def direct_image(path):
    """
    No login is required for a direct link to this image.
    This will return the image that can be used as src.
    @param path: the full path to the image
    @return: the url that can be used directly for src
    """

    # graph object was not created, it has no entry in the db, it's just a file, so we serve it
    f = open(path, 'r')
    content = f.read()
    f.close()
    response = HttpResponse(content, 'image/png') # TODO: nicer detection for mimetype
    response['Content-Length'] = len(content)
    return response
