
import os

from django.conf import settings
import datetime

from threading import Lock
lock1 = Lock()
lock2 = Lock()

def today():
    if settings.VIRTUAL_DATE is None:
        return datetime.datetime.now().date()

    if not os.path.exists(settings.VIRTUAL_DATE):
        set_date(datetime.datetime.now())

    lock1.acquire()

    f = open(settings.VIRTUAL_DATE)
    content = f.read()
    f.close()

    dt = datetime.datetime.strptime(content, "%Y-%m-%d").date()

    lock1.release()

    return dt

def now():
    """
    returns the virutal date with current time
    """
    t = today()
    n = datetime.datetime.now()
    dt = datetime.datetime(t.year, t.month, t.day, n.hour, n.minute, n.second)

    return dt


def set_date(dt):

    assert isinstance(dt, datetime.date)

    if settings.VIRTUAL_DATE is None:
        raise Exception('cannot set virtual date')

    lock2.acquire()

    f = open(settings.VIRTUAL_DATE, 'w')
    f.write( dt.strftime('%Y-%m-%d') )
    f.close()

    lock2.release()

