# Copyright (c) 2010 BaseSoft B.V.
# See LICENSE for details.

from django.utils.translation import ugettext, ugettext_lazy as _
from basesoft.web.core.config import DefaultConfig

class AccountConfig(DefaultConfig):
    permissions = None
    label = _('Account settings')
    is_expanded = True

    def configs(self):
        return {
            'basesoft.web.contrib.locale': {
                'label': ugettext('Select language'),
                'options': {
                    'optionsRpcUrl': '/basesoft.web.contrib.i18n/rpc/',
                    'optionsRpcMethod': 'get_site_translations_locales',
                    'emptyFirstOption': False
                }
            },
            'basesoft.web.core.media.themes': {
                'label': ugettext('Display theme'),
                'options': {
                    'optionsRpcUrl': 'basesoft.web.contrib.license.ThemesRPCHandler',
                    'optionsRpcMethod': 'get_available_themes',
                    'emptyFirstOption': True,
                    'disableWhenSingleOption': True,
                }
            },
            'basesoft.web.core.growl.position': {
                'label': ugettext('Information message position'),
                'options': {
                    'options': {
                        'tl': ugettext('Top-left corner'),
                        'tr': ugettext('Top-right corner'),
                        'bl': ugettext('Bottom-left corner'),
                        'br': ugettext('Bottom-right corner')
                    }
                }
            },
            'basesoft.web.core.effects.enabled': {
                'label': ugettext('Enable visual effects throughout the site'),
            }

        }

configs = (AccountConfig(), )