# Copyright (c) 2010 BaseSoft B.V.
# See LICENSE for details.

from basesoft.web.core.jsonrpc.dispatcher import JsonRpcDispatcher
from basesoft.web.core.input.validation import plugins
from basesoft.web.core.forms.handler import FormValidator

def header_footer_form_validation(request):
    """View that handles form validation in the h/f detail interface"""

    form_handler = FormValidator(
        fields = {
            'name': [(plugins.Required, {})],
            'content': [(plugins.Required, {})],
        }
    )
    dispatcher = JsonRpcDispatcher()
    dispatcher.register_instance(form_handler)
    return dispatcher.handle_request(request)
