# Copyright (c) 2009 BaseSoft B.V.
# See LICENSE for details.

from django.utils.translation import ugettext_lazy as _

from basesoft.web.contrib.account.decorators import assert_user_logged_in
from basesoft.web.contrib.iconbar.models import IconBarIcon

class FileManagerIcon(IconBarIcon):
    """
    Class responsible for handling the file manager icon
    """

    id = 'icon-file-manager'
    title = _('File manager')
    icon_index = 85
    component = 'iq_file_manager'
    group = 'file'

    char_main = u'\uE81c' # Home icon

    @assert_user_logged_in
    def assert_permissions(self, controller):
        """
        this is shown only if the permissions are met
        """
        controller.assert_permissions('file_manager')

def get_icons():
    """
    return the list of icons that the home app adds to the iconbar
    """

    return [FileManagerIcon()]
