# Copyright (c) 2008 BaseSoft B.V.
# See LICENSE for details.

from django.utils.translation import ugettext_lazy as _

from basesoft.web.contrib.iconbar.models import IconBarIcon

class IQPortalHomeIcon(IconBarIcon):
    """
    Class responsible for handling the home icon
    """

    id = 'icon-home'
    title = _('Home')
    app = 'home'
    icon_index = 0 # first icon
    group = 'home'

    char_main = u'\uE80f' # Home icon

    def assert_permissions(self, controller):
        """
        Home is shown all the time
        """
        from basesoft.web.contrib.home.controllers import HomeController

        account_id = None
        account = controller.get_account()
        if account is not None:
            account_id = account.id

        hc = HomeController(controller.sa_session, account_id=account_id, request=self.request)
        self.app = hc.get_home_application()

def get_icons():
    """
    return the list of icons that the home app adds to the iconbar
    """
    return [IQPortalHomeIcon()]
