# Copyright (c) 2008 BaseSoft B.V.
# See LICENSE for details.

from django.utils.translation import ugettext_lazy as _

from basesoft.web.contrib.account.decorators import assert_user_logged_in
from basesoft.web.contrib.iconbar.models import IconBarIcon

class IQPortalMailIcon(IconBarIcon):
    """
    Class responsible for handling the mail compose icon
    """

    id = 'icon-mail-manager'
    title = _('Mail manager')
    icon_index = 65
    component = 'iq_mail_manager'
    group = 'mailing'

    char_main = u'\uE81a' # Mail icon

    @assert_user_logged_in
    def assert_permissions(self, controller):
        """
        this is shown only if the permissions are met
        """
        controller.assert_permissions('view_mail')

def get_icons():
    """
    return the list of icons that the mail app adds to the iconbar
    """

    return [IQPortalMailIcon()]
