
from iqportal.iqube.core.db_sync import AbstractConfigurableWidget
from basesoft.web.contrib.order.iqube_sync import OrderCube

class AbstractOrderResultWidget(AbstractConfigurableWidget):

    def config(self):
        return {
            "reporter": "iqportal.iqube.core.ConfigurableWidgetReporter",
            "show_last_aggregation_update": True,
            "category": "Order",
            "has_quick_filter": True,
            "has_drill_through": False,
            "show_hide_empty": True,
            "transposable": True,
            "label": "Order result",
            "show_excel_export": True,
            "has_drill_position": False,
            "cube": "%s" % self.cube_object.name,
            "has_graph": True,
            "id": 1,
            "table_object_name": "datatablecube",
            "table_module": "iqreport_graph_datatablecube",
            "has_table": True,
            "has_hierarchy_names": True,
            "graph_config": {},
            "has_drill_replace": False,

            "dimensions": [{
                "caption": "%s" % self.cube_object.MERCHANT_LABEL,
                "available_on_rows": True,
                "show_named_sets": False,
                "has_select_as_group": True,
                "available_as_split_by": False,
                "required": False,
                "show_full_caption": True,
                "available_as_slicer": True,
                "fancy_select_module": "iq_fancyselect",
                "available_on_columns": True,
                "show_calculated_members": False,
                "children": [                {
                    "unique_name": "[%s].[%s]" % (self.cube_object.MERCHANT_LABEL, self.cube_object.MERCHANT_LABEL),
                    "has_children_available": True,
                    "caption": "%s" % self.cube_object.MERCHANT_LABEL,
                    "has_all_member_available": True,
                    "show_members": True,
                    "method_argument": "[%s].[%s]" % (self.cube_object.MERCHANT_LABEL, self.cube_object.MERCHANT_LABEL),
                    "method": "get_level_members"
                }]
                }, {
                "caption": "%s" % self.cube_object.CLIENT_LABEL,
                "available_on_rows": True,
                "show_named_sets": False,
                "has_select_as_group": True,
                "available_as_split_by": False,
                "required": False,
                "show_full_caption": True,
                "available_as_slicer": True,
                "fancy_select_module": "iq_fancyselect",
                "available_on_columns": True,
                "show_calculated_members": False,
                "children": [{
                        "unique_name": "[%s].[%s]" % (self.cube_object.CLIENT_LABEL, self.cube_object.CLIENT_LABEL),
                        "has_children_available": True,
                        "caption": "%s" % self.cube_object.CLIENT_LABEL,
                        "has_all_member_available": True,
                        "show_members": True,
                        "method_argument": "[%s].[%s]" % (self.cube_object.CLIENT_LABEL, self.cube_object.CLIENT_LABEL),
                        "method": "get_level_members"
                }]
                }, {
                "caption": "GL Account",
                "available_on_rows": True,
                "show_named_sets": False,
                "has_select_as_group": True,
                "available_as_split_by": False,
                "required": False,
                "show_full_caption": True,
                "available_as_slicer": True,
                "fancy_select_module": "iq_fancyselect",
                "available_on_columns": True,
                "show_calculated_members": False,
                "children": [                {
                    "unique_name": "[GL Account].[GL Account]",
                    "has_children_available": True,
                    "caption": "Client",
                    "has_all_member_available": True,
                    "show_members": True,
                    "method_argument": "[GL Account].[GL Account]",
                    "method": "get_level_members"
                }]
                }, {
                "caption": "Invoice Type",
                "available_on_rows": True,
                "show_named_sets": False,
                "has_select_as_group": True,
                "available_as_split_by": False,
                "required": False,
                "show_full_caption": True,
                "available_as_slicer": True,
                "fancy_select_module": "iq_fancyselect",
                "available_on_columns": True,
                "show_calculated_members": False,
                "children": [                {
                    "unique_name": "[Invoice Type].[Invoice Type]",
                    "has_children_available": True,
                    "caption": "Invoice Type",
                    "has_all_member_available": True,
                    "show_members": True,
                    "method_argument": "[Invoice Type].[Invoice Type]",
                    "method": "get_level_members"
                }]
                },{
                "caption": "Order Type",
                "available_on_rows": True,
                "show_named_sets": False,
                "has_select_as_group": True,
                "available_as_split_by": False,
                "required": False,
                "available_as_slicer": True,
                "fancy_select_module": "iq_fancyselect",
                "available_on_columns": True,
                "show_calculated_members": False,
                "children": [                {
                    "unique_name": "[Order Type].[Order Type]",
                    "has_children_available": True,
                    "caption": "Order Type",
                    "has_all_member_available": True,
                    "show_members": True,
                    "method_argument": "[Order Type].[Order Type]",
                    "method": "get_level_members"
                }]
                },
                {
                "caption": "Submit Period",
                "available_on_rows": True,
                "show_named_sets": False,
                "has_select_as_group": True,
                "available_as_split_by": False,
                "required": False,
                "show_full_caption": True,
                "available_as_slicer": True,
                "fancy_select_module": "level_filter_fancy_select",
                "fancy_select_optionsRpcUrl": 'iqportal.iqube.core.IQubeRPCHandler',
                "fancy_select_RpcMethod": 'get_time_children',

                "available_on_columns": True,
                "show_calculated_members": False,
                "children": [{
                    "unique_name": "[Submit Period.Quarter].[Year]",
                    "has_children_available": False,
                    "caption": "Quarter",
                    "has_all_member_available": False,
                    "show_members": True,
                    "method_argument": "[Submit Period.Quarter].[Year]",
                    "method": "get_level_members",
                    "has_drill_enabled": True,
                }, {
                    "unique_name": "[Submit Period.WeekISO8601].[Year]",
                    "has_children_available": False,
                    "caption": "Week",
                    "has_all_member_available": False,
                    "show_members": True,
                    "method_argument": "[Submit Period.WeekISO8601].[Year]",
                    "method": "get_level_members",
                    "has_drill_enabled": True,
                }, ]

                }, {
                "caption": "Payment Period",
                "available_on_rows": True,
                "show_named_sets": False,
                "has_select_as_group": True,
                "available_as_split_by": False,
                "required": False,
                "show_full_caption": True,
                "available_as_slicer": True,
                "fancy_select_module": "level_filter_fancy_select",
                "fancy_select_optionsRpcUrl": 'iqportal.iqube.core.IQubeRPCHandler',
                "fancy_select_RpcMethod": 'get_time_children',

                "available_on_columns": True,
                "show_calculated_members": False,
                "children": [{
                    "unique_name": "[Payment Period.Quarter].[Year]",
                    "has_children_available": False,
                    "caption": "Quarter",
                    "has_all_member_available": False,
                    "show_members": True,
                    "method_argument": "[Payment Period.Quarter].[Year]",
                    "method": "get_level_members",
                    "has_drill_enabled": True,
                }, {
                    "unique_name": "[Payment Period.WeekISO8601].[Year]",
                    "has_children_available": False,
                    "caption": "Week",
                    "has_all_member_available": False,
                    "show_members": True,
                    "method_argument": "[Payment Period.WeekISO8601].[Year]",
                    "method": "get_level_members",
                    "has_drill_enabled": True,
                },]

                }, {
                "caption": "Payment Method",
                "available_on_rows": True,
                "show_named_sets": False,
                "has_select_as_group": True,
                "available_as_split_by": False,
                "required": False,
                "available_as_slicer": True,
                "fancy_select_module": "iq_fancyselect",
                "available_on_columns": True,
                "show_calculated_members": False,
                "children": [                {
                    "unique_name": "[Payment Method].[Payment Method]",
                    "has_children_available": True,
                    "caption": "Invoice Type",
                    "has_all_member_available": True,
                    "show_members": True,
                    "method_argument": "[Payment Method].[Payment Method]",
                    "method": "get_level_members"
                }]
                }, {
                "caption": "Measures",
                "available_on_rows": True,
                "show_named_sets": False,
                "has_select_as_group": False,
                "available_as_split_by": False,
                "required": False,
                "available_as_slicer": True,
                "fancy_select_module": "iq_fancyselect",
                "available_on_columns": True,
                "show_calculated_members": False,
                "children": [
                {
                    "unique_name": "[Measures].[MeasuresLevel]",
                    "has_children_available": True,
                    "caption": "MeasuresLevel",
                    "has_all_member_available": False,
                    "show_members": True,
                    "method_argument": "[Measures].[MeasuresLevel]",
                    "method": "get_level_members"
                }]
                },
            ],
        }

    def applied_filters(self):
        return {
            "dimensions": {
                "%s" % self.cube_object.MERCHANT_LABEL: "0",
                "%s" % self.cube_object.CLIENT_LABEL: "1",
                "GL Account": "2",
                "Invoice Type": "3",
                "Order Type": "4",
                "Submit Period": "5",
                "Payment Period": "6",
                "Payment Method": "7",
                "Measures": "8",
            },


            "axes_0": "",
            "axes_1": "",
            "axes_2": "",
            "axes_3": "",
            "axes_4": "",
            "axes_5": "",
            "axes_6": "",
            "axes_7": "",
            "axes_8": "columns",

            "dimension_0": [],
            "dimension_1": [],
            "dimension_2": [],
            "dimension_3": [],
            "dimension_4": [],
            "dimension_5": [],
            "dimension_6": [],
            "dimension_7": [],
            "dimension_8": ["[Measures].[Amount (excl. vat)]"],

            "column_order": [
                "Measures",
            ],
            "row_order": [
            ],

            "show_table": True,
            "show_slicers": True,

            "initialRefresh": False,

        }

class OrderResultWidget(AbstractOrderResultWidget):
    cube_object = OrderCube
    category = 'Order'
    cube = 'Order'
    datasource = 'Order'



configurable_widgets = (OrderResultWidget,)
