'''
Created on Oct 30, 2013

@author: marten
'''
from basesoft.web.contrib.mailing.controllers import MailBaseController
from basesoft.web.contrib.account.mailing import AbstractAccountMailStateController
from basesoft.web.contrib.order.models import NewInvoiceMail

class NewInvoiceMailStateController(AbstractAccountMailStateController):

    _instance_class = NewInvoiceMail

    # permissions needed for using this kind of mail
    CREATE_ACCESS_PERMISSIONS   = ['create_invoice_mail']
    VIEW_ACCESS_PERMISSIONS     = ['view_invoice_mail']
    UPDATE_ACCESS_PERMISSIONS   = ['update_invoice_mail']
    DELETE_ACCESS_PERMISSIONS   = ['delete_invoice_mail']
    SCHEDULE_ACCESS_PERMISSIONS = []

class MailController(MailBaseController):
    """
    Class that's on top of the MailBaseController. This is used for
    handling InvoiceMail objects.
    """
    # mapping between object type and the controller
    _state_controllers = {
        'NewInvoiceMail': NewInvoiceMailStateController,
    }
