'''
Created on Oct 15, 2013

@author: marten
'''

import re

from basesoft import logging
from pyws.functions.args.types.base import Type
from pyws.functions.args.types.simple import String
logger = logging.getLogger("basesoft.web.contrib.soap")

class base64Binary(Type):
    @classmethod
    def represents(cls, type_):

        logger.info('base64Binary:represents, cls: %s' % cls)
        logger.info('base64Binary:represents, type_: %s' % type_)

        return isinstance(type_, base64Binary)

    @classmethod
    def get(cls, type_):
        return 'base64Binary'

    @classmethod
    def _validate(cls, value):
        return value.decode('base64')

class str_safe(String):

    @classmethod
    def serialize(self, text):
        """
        removes utf-8 control chars
        """
        return re.sub(r"[\x01-\x1F\x7F]", "", text)
