'''
Created on Oct 15, 2013

@author: marten
'''
from datetime import datetime, date
import decimal
from basesoft.web.contrib.soap.args import base64Binary, str_safe as str

LabelValueDict = {
    0: 'LabelValueDict',
    'id': int,
    'name': str
}

KeyValueDict = {
    0: 'KeyValueDict',
    'key': str,
    'value_int': int,
    'value_str': str,
    'value_decimal': decimal.Decimal,
    'value_datetime': datetime,
    'value_base64Binary': base64Binary
}

# Master Data stuff
CompanyDict = {
    0: 'CompanyDict',
    'name': str,
    'vat_no': str
}

PersonDict = {
    0: 'PersonDict',
    'first_name': str,
    'middle_name': str,
    'last_name': str,
    'title': str,
    'email': str,
    'phone': str,
    'mobile_phone': str,
    'skype_name': str,
    'preferred_locale_str': str
}

AddressDict = {
    0: 'AddressDict',
    'street': str,
    'postcode': str,
    'state': str,
    'city': str,
    'country': int,
    'country_name': str,
    'country_iso_3166_a2': str,
    'country_iso_3166_a3': str,
}

BankDict = {
    0: 'BankDict',
    'number': str,
    'iban': str,
    'bic': str,
    'beneficiary': str,
    'bank_name': str,
    'address': AddressDict
}

MasterDataDict = {
    0: 'MasterDataDict',
    'id': int,
    'company': CompanyDict,
    'contact_person_data': PersonDict,
    'invoice_person_data': PersonDict,
    'bank_data': BankDict,
    'address_data': AddressDict,
    'created': datetime,
    'last_updated': datetime
}

# Order Data
OrderDataLineDict = {
    0: 'OrderDataLineDict',
    'index': int,
    'polymorphic_type': str,
    'description': str,
    'quantity': int,
    'price_per_unit': decimal.Decimal,
    'vat_rate': decimal.Decimal,
    'gl_account': str,
    'line_amount_excluding_vat': decimal.Decimal,
    'line_amount_including_vat': decimal.Decimal,
    'properties': [KeyValueDict]
}

OrderDataDict = {
    0: 'OrderDataDict',
    'id': int,
    'merchant_id': int,
    'client_id': int,
    'type': int, # Credit or Debit
    'polymorphic_type': str,
    'lines': [OrderDataLineDict],
    'currency_code': str,
    'total_amount_excluding_vat': decimal.Decimal,
    'total_amount_including_vat': decimal.Decimal,
    'invoiced_amount': decimal.Decimal,
    'current_payment_method_id': int,
    'current_payment_method_label': str,
    'current_payment_status': int,
    'current_payment_date': datetime,
    'created': datetime,
    'last_updated': datetime,
    'export_date': date,
    'properties': [KeyValueDict],


}

Document = {
    0: 'Document',
    'file_name': str,
    'payload': base64Binary,
}