# Copyright (c) 2013 BaseSoft B.V.
# See LICENSE for details.
from functools import partial

from pyws.protocols.soap import SoapProtocol, get_context_data_from_headers
from pyws.functions.args import TypeFactory

def get_context_data(request, headers_schema=None):
    print request, headers_schema
    rv = get_context_data_from_headers(request, headers_schema)
    if rv is None:
        return request
    return rv

class IQPortalSoapProtocol(SoapProtocol):
    def __init__(
            self, service_name, tns, location,
            headers_schema=None, *args, **kwargs):
        """
        ``service_name`` gives a name to the server, it is used to generate
        WSDL file. ``tns`` is a root namespace, where all the stuff lives, SOAP
        is based on XML, so no wonder we need it. ``location`` tells the
        server, where it lives. It is only a piece of information required by
        pyws to generate a proper WSDL file, it is not a real binding to an
        URL. ``headers_schema`` a schema used to retrive context data from
        request headers. Other arguments are passed to parent constructor.
        """

        headers_schema = headers_schema and TypeFactory(headers_schema)
        context_data_getter = partial(get_context_data, headers_schema=headers_schema)

        super(SoapProtocol, self).\
            __init__(context_data_getter, *args, **kwargs)

        self.service_name = service_name
        self.tns = tns
        self.location = location
        self.headers_schema = headers_schema