# Copyright (c) 2010 BaseSoft B.V.
# See LICENSE for details.

from django.utils.translation import ugettext, ugettext_lazy as _
from basesoft.web.contrib.account.models import Config

class DefaultConfig:
    is_expanded = False
    _controller = None

    def set_controller(self, c):
        self._controller = c

    def has_permissions(self, c, license_id=None):
        if self.permissions is None:
            return True
        return c.has_permissions(*self.permissions, license_id=license_id)

    def get_config(self, sa_session):
        configs = []

        for name, settings in self.configs().iteritems():
            c = sa_session.query(Config).filter(Config.name==name).one()
            cfg = settings
            cfg['name'] = name
            cfg['type'] = c.type
            configs.append(cfg)

        return {'label': self.label, 'is_expanded': self.is_expanded, 'configs': configs}

    def get_form_behaviour(self, validators, values):
        return validators

class DashboardConfig(DefaultConfig):
    permissions = ('save_dashboard', )
    label = _('Dashboard settings')

    def configs(self):
        return {
            'basesoft.dashboard.compose.remove.confirmation': {'label': ugettext('Show removal confirmation')},
        }


configs = (DashboardConfig(), )
