# Copyright (c) 2008 BaseSoft B.V.
# See LICENSE for details.

from exceptions import SecurityException
from django.conf import settings

def assert_debug_mode(method):
    """
    This decorator checks if the debug is set to true, and if not, raises a
    SecurityException
    """
    def is_debug_mode(*args, **kwargs):
        if settings.DEBUG:
            return method(*args, **kwargs)
        raise SecurityException('Debug is set to False.')
    return is_debug_mode

