from django.http import HttpResponse

import Image
from ImageDraw import Draw
from ImageFont import truetype
from basesoft.fonts.fontconfig import find_font

def make_image(request, caption):

    font = truetype(find_font('Arial.ttf'), 12)

    image = Image.new("RGBA", (600,150), (255,255,255))
    draw = Draw(image)
    w, h = draw.textsize(caption, font=font)

    image = Image.new("RGBA", (w,h), (255,255,255))
    draw = Draw(image)
    draw.text((0, 0), caption, (0,0,0), font=font)

    response = HttpResponse(mimetype="image/png")
    image.save(response, "PNG")

    return response
