# Copyright (c) 2010 BaseSoft B.V.
# See LICENSE for details.

from django.utils.translation import ugettext as _

from basesoft.web.core.util.custom_query import CustomQuery, CustomQueryField, CustomQueryModel

from basesoft.web.dev.compose.models import Mockup, MockupCategory

class MockupCustomQuery(CustomQuery):
    permissions = ('develop_tools', )

    def tables(self):
        return (
            CustomQueryModel(Mockup),
            CustomQueryModel(MockupCategory, onclause=Mockup.category_id==MockupCategory.id),
        )

    def fields(self):
        return (
            CustomQueryField(Mockup.id, _('ID')),
            CustomQueryField(Mockup.name, _('Name'), is_filter=True),
            CustomQueryField(MockupCategory.id, _('Category'), in_select=False, is_filter=True, filter_options=MockupCategory.label),
            CustomQueryField(MockupCategory.label, _('Category'), is_group_by=True),
            CustomQueryField(Mockup.created, _('Created')),
            CustomQueryField(Mockup.last_updated, _('Last updated')),
        )

custom_queries = (MockupCustomQuery, )