# Copyright (c) 2009 BaseSoft B.V.
# See LICENSE for details.

from basesoft.web.core.models import PrivilegeObject

class MockupCategory(PrivilegeObject):
    """
    Model representing a mockup category
    @DynamicAttrs
    """
    def get_group_object(self):
        return (MockupCategoryGroup, 'category')

    def __repr__(self):
        return '<MockupCategory id=%s>' % self.id

class MockupCategoryGroup(object):
    """
    Model representing the link between mockup categories and groups. Used for permissions.
    @DynamicAttrs
    """
    pass

class Mockup(PrivilegeObject):
    """
    Model representing a mockup
    @DynamicAttrs
    """

    def get_group_object(self):
        return (MockupGroup, 'mockup')

    def __repr__(self):
        return '<Mockup id=%s>' % self.id

class MockupGroup(object):
    """
    Model representing the link between mockups and groups. Used for permissions.
    @DynamicAttrs
    """
    pass
