'''
Created on Feb 27, 2012

@author: marten
'''
from basesoft.web.dev.util.controllers import IQuestPHP4ImportResponseController
from basesoft.web.core.forms.handler import FormValidator

from iqportal.iquest.compose.controllers import ComposeController

class ImportResponseRPCHandler:
    def __init__(self, request, **kwargs):
        self.request = request
        self.sa_session = request.Session()
        self.account_id = request.session['user_id']
        self.controller = IQuestPHP4ImportResponseController(self.sa_session, account_id=self.account_id)

    def validate_import_settings(self, args):
        from basesoft.web.core.input.validation import plugins
        form_handler = FormValidator({
            'survey': [(plugins.Required, {})],
            'contact_list': [(plugins.Required, {})],
            'publication_label': [(plugins.Required, {})],
            'begin_date': [(plugins.Required, {})],
            'import_file': [(plugins.Required, {})],
        })
        return form_handler.validate(args)


    def validate_contacts(self, args):
        return True

    def get_available_contact_fields_from_import_file(self, file_hash=None):
        """
        These start on row 3
        """
        if file_hash is None or file_hash == '':
            return []
        rows = self.controller.set_import_file(file_hash)
        return [{'label': val, 'value': index, 'default': (val=='FME Relatienummer')} for index, val in enumerate(rows[3]) if val != ""]

    def get_survey_qa_items(self, survey=None, file_hash=None):
        rv = {'qas': [], 'options': []}
        if file_hash is None or file_hash == '':
            return rv
        if survey is None or survey == '':
            return rv

        c = ComposeController(self.sa_session, None, self.account_id)

        rows = self.controller.set_import_file(file_hash)
        rv['options'] = [{'label': val, 'value': index} for index, val in enumerate(rows[0]) if val != ""]
        rv['qas'] = [{'value': i.item.id, 'label': i.label} for i in c.get_qa_locales(survey)]
        return rv

    def validate_import_file(self, survey, file_hash, company_nr_field, contact_list_id, qa_matches, publish_label, begin_date):
        failures, messages = self.controller.validate_import_file(survey, file_hash, company_nr_field, contact_list_id, qa_matches, publish_label)
        if len(failures) > 0:
            return {'messages': failures, 'warn': True}
        return {'messages': messages, 'warn': False}

    def import_responses(self, survey, file_hash, company_nr_field, contact_list_id, qa_matches, publish_label, begin_date):
        self.controller.import_responses(survey, file_hash, company_nr_field, contact_list_id, qa_matches, publish_label, begin_date)

handlers = (ImportResponseRPCHandler, )
