# Copyright (c) 2010 BaseSoft B.V.
# See LICENSE for details.

from basesoft.web.core.jsonrpc.dispatcher import JsonRpcDispatcher
from basesoft.web.contrib.account.decorators import assert_user_logged_in
from basesoft.web.dev.util.controllers import IQuestPHP4ConversionController


@assert_user_logged_in
def rpc(request):
    dispatcher = JsonRpcDispatcher()

    class Handler:

        def __init__(self, session, account_id):
            self.controller = IQuestPHP4ConversionController(session, account_id)

        def get_publications(self, host, db, user, password):
            self.controller.set_connection(host, db, user, password)
            return self.controller.get_publications()

        def convert_publications(self, host, db, user, password, source, target):
            self.controller.set_connection(host, db, user, password)
            return self.controller.convert_survey_publications(source, target)

    dispatcher.register_instance(Handler(request.Session(), request.session['user_id']))

    return dispatcher.handle_request(request)