# Copyright (c) 2008 BaseSoft B.V.
# See LICENSE for details.
"""
Database/SQLAlchemy configuration
"""
import time
from basesoft import logging
logger = logging.getLogger('basesoft.django.middleware')

class SAEngineMiddleware(object):
    """
    Middleware for creating thread-local Session Template objects
    """
    def process_request(self, request):
        from basesoft.web.core.util.db import Session, SessionReadOnly
        from django.conf import settings
        
        request.Session = Session()
        if settings.DB_CONNSTR_READONLY != settings.DB_CONNSTR:
            request.SessionReadOnly = SessionReadOnly()
        else:
            request.SessionReadOnly = request.Session

    def process_exception(self, request, exception):
        request.Session.remove()
        request.SessionReadOnly.remove()
        return None

    def process_response(self, request, response):
        request.Session.remove()
        request.SessionReadOnly.remove()
        return response
