# Copyright (c) 2011 BaseSoft B.V.
# See LICENSE for details.

from django.utils.translation import ugettext_lazy as _

from basesoft.web.contrib.account.decorators import assert_user_logged_in
from basesoft.web.mobile.models import MobileIcon

class MobileHomeIcon(MobileIcon):
    """
    """

    id = 'icon-mobile-home'
    title = _('Home')
    name = 'mobile-home'
    image = '/site_media/basesoft.web.contrib.basesoft/75x75/apps/preferences-desktop-wallpaper.png'
    icon_index = 1
    js_module = 'mobile_app_home'
    in_home_menu = False

    #@assert_user_logged_in
    def has_permissions(self, controller):
        """
        this is shown only if the permissions are met
        """
        return True

def get_icons():
    return [MobileHomeIcon()]
