#!/bin/bash

#
# This file gets executed by the scheduler for stable
#
# It checks if there are new files on the arvato ftp, then retrieves and unpacks them locally to the given destination
#

# save destination dir in variable
dest=$1
if [ "$1" == "" ]; then
	echo 'ERROR: missing destination dir'
	exit 1;
fi

cd $dest

# password used in ssh commands
export SSHPASS=onrz67

# sftp command to arvato
# requirement to run this command is that the host key is already accepted else it will fail
arvato_sftp="sshpass -e sftp -oBatchMode=no -b - mov_dc_232@filetransfer.arvato-services.de"

# retrieve all files
echo "get from_arvato/*" | $arvato_sftp

# if the above command failed, no new files were found
if [ $? -ne  0 ]; then
	echo 'no new files'
	exit 0;
fi

# remove all files from ftp
echo "rm from_arvato/*" | $arvato_sftp

# unpack zip files and remove if unziped ok
find *.zip -exec sh -c "unzip -o '{}' && rm '{}'" \;
