'''
Created on Nov 20, 2013

@author: marten
'''
from datetime import datetime

from basesoft.web.contrib.contact.controllers import ImportContactController, SimpleContactController

from iqportal.client.arvato.models import ArvatoContact

class ArvatoContactController(SimpleContactController):
    _instance_class = ArvatoContact

    def person_required_columns(self):
        return [['email', 'language', 'person_country_iso_3166_a2']]

    def get_contact_cols(self):
        c = SimpleContactController.get_contact_cols(self)
        for key, v in ArvatoContact.cols_i18n.items():
            c.append({"value": key, "label": v})
        return c

class ArvatoImportContactController(ImportContactController):

    __date_format = '%d.%m.%Y %H:%M:%S'

    def get_simple_contact_controller(self, objectName):
        """
        Overwrite so it doesn't search all apps again
        """
        return ArvatoContactController

    def _extract_states(self, state):
        person_data, company_data, contact_data = super(ArvatoImportContactController, self)._extract_states(state)

        contact_data['case_created'] = datetime.strptime(contact_data['case_created'], self.__date_format)

        return person_data, company_data, contact_data

contact_controllers = {'ArvatoContact': ArvatoContactController}
import_contact_controllers = {'ArvatoContact': ArvatoImportContactController}
