# Copyright (c) 2012 BaseSoft B.V.
# See LICENSE for details.

from sqlalchemy.orm import join
from sqlalchemy import and_
from sqlalchemy.orm.exc import NoResultFound

from basesoft.web.contrib.license.models import Group, License, Domain
from iqportal.tnt.core.models import TntGeolevel, TntGeolevelType
from basesoft.web.contrib.i18n.models import DomainCountry, Country

from basesoft.web.contrib.graph.db_sync import sync_color_sets
from basesoft.web.contrib.graph.models import ColorSet, GraphTheme
from django.utils import simplejson
from basesoft.web.core.jsonrpc.dispatcher import JsonRpcJSONEncoder

from iqportal.iqreport.core.models import ReportTheme
from basesoft.web.contrib.graph.models import GraphTheme
from iqportal.iqreport.core.db_sync import sync_report_themes

synced_apps = [] # global used to see what apps have already been synced until now

def sync(session):

    # nothing to sync if no FME domain
    fme_domain = None
    try:
        fme_domain = session.query(Domain).filter(Domain.name=='FME').one()
        sync_fme_domain_countries(session, fme_domain)
    except NoResultFound:
        print 'no FME domain, skip syncing..'


def sync_fme_domain_countries(session, fme_domain):

    #print 'sync FME countries...'
    countries = {
        'NL': 'Nederland',
        'BE': 'Belgie'
    }

    for country_code, domain_country_name in countries.iteritems():
        try:
            dc = session.query(DomainCountry) \
                .join(Country) \
                .filter(DomainCountry.domain == fme_domain) \
                .filter(Country.iso_3166_a2 == country_code).one()
        except NoResultFound:
            dc = DomainCountry()
            dc.domain = fme_domain
            dc.name = domain_country_name
            dc.country = session.query(Country).filter(Country.iso_3166_a2 == country_code).one()
            dc.active = True
            session.add(dc)

    # and its gone
    session.flush()