# Copyright (c) 2011 BaseSoft B.V.
# See LICENSE for details.

from basesoft.web.contrib.contact.models import Company, Person, Contact
from django.utils.translation import ugettext as _

class FMECompany(Company):
    """
    @DynamicAttrs
    """
    NAME_I18N = _('FME Company')
    STR = 'FMECompany'
    JS_MODULE = 'iq_company_form'

    cols_i18n = dict(Company.cols_i18n.items() + {
        "company_number": _("FME Company Number"),
        "no_of_employees": _("No. of employees"),
        "department_number": _("Department number"),
        "busrelaccount": _("Busrelaccount"),
        "CAO": _("CAO")
    }.items())

    def __repr__(self):
        return '<FMECompany company_number=%s>' % self.company_number

class FMEPerson(Person):
    """
    @DynamicAttrs
    """
    NAME_I18N = _('FME Person')
    STR = 'FMEPerson'
    JS_MODULE = 'iq_person_form'

    cols_i18n = dict(Person.cols_i18n.items() + {
        "person_number": _("FME Person Number"),
        "internal_location": _("Internal location")
    }.items())

    def __repr__(self):
        return '<FMEPerson person_number=%s>' % self.person_number

class FMEContact(Contact):
    """
    @DynamicAttrs
    """
    NAME_I18N = _('FME Contact')
    PERMISSIONS = ("fme_contact_access", )
    STR = 'FMEContact'

    person_instance_class = FMEPerson
    company_instance_class = FMECompany

    def __repr__(self):
        return '<FMEContact contact_id=%s>' % self.contact_id

