# Copyright (c) 2010 BaseSoft B.V.
# See LICENSE for details.

from django.utils.translation import ugettext, ugettext_lazy as _
from basesoft.web.core.config import DefaultConfig

class IQReportConfig(DefaultConfig):
    permissions = ['item_result', 'use_dynamic_table_in_report', 'use_dynamic_table_on_dashboard', 'view_datasource_widget']
    label = _('Report settings')
    is_expanded = False

    def has_permissions(self, c):
        """
        Override this method because for this config option *any* (vs all) of the listed permissions are valid.
        """
        if self.permissions is None:
            return True
        return c.has_any_permissions(*self.permissions)

    def configs(self):
        return {
            'iqreport.core.graph.animate': {
                'label': ugettext('Use graph animations')
            },
            'iqreport.core.graph.prefer_flash': {
                'label': ugettext('Use Adobe Flash to render graphs')
            },

        }

configs = (IQReportConfig(), )