# Copyright (c) 2009 BaseSoft B.V.
# See LICENSE for details.

from django.utils.translation import ugettext_lazy as _

from basesoft.web.contrib.dashboard.controllers import DashboardWidgetCQStateController, DashboardWidgetStateController
from basesoft.util.ordered_dict import OrderedDict

from iqportal.iqreport.core.controllers import DashboardDynamicTableController

class ReportPublicationOverviewWidget(DashboardWidgetCQStateController):
    """
    Publication Overview Widget
    """
    label = _('Publication overview')
    name = 'iq_db_report_publish_overview_widget'
    icon = '16x16/categories/applications-accessories.png'
    category = 'IQReport'
    permissions = ['view_report_publication']


class DynamicTableWidget(DashboardDynamicTableController):
    name = 'db_dynamic_table'
    icon = '16x16/mimetypes/x-office-presentation.png'
    label = _('Dynamic table')
    category = 'IQReport'
    permissions = ['use_dynamic_table_on_dashboard']

class ReportManagerWidget(DashboardWidgetCQStateController):
    """
    Survey Manager Widget
    """
    label = _('Report overview')
    name = 'iq_db_report_manager'
    icon = '16x16/places/folder.png'
    category = 'IQReport'
    permissions = ['view_report']

class ItemResultWidget(DashboardWidgetStateController):
    name = 'db_item_result'
    icon = '16x16/mimetypes/x-office-presentation.png'
    label = _('Results')
    category = 'IQReport'
    permissions = ['item_result']

widgets_mapper = OrderedDict([
     ('ReportPublicationOverviewWidget', ReportPublicationOverviewWidget),
     ('DynamicTableWidget', DynamicTableWidget),
     ('ReportManagerWidget', ReportManagerWidget),
     ('DbItemResultWidget', ItemResultWidget),
])

