# Copyright (c) 2009 BaseSoft B.V.
# See LICENSE for details.
from iqportal.iqreport.core import views

base_modules = {

    # dynamic module that fills some BASESOFT.env variables
    'iq_report_env': {
        'type': 'js',
        'path': views.js_module_iq_report_env,
    },

    'iqreport_datatablecube': {
        'type': 'js',
        'path': 'datatablecube-min.js',
        'requires': ['datatable', 'iqreport_datatablecube_css']
    },

    'iqreport_datatablecube_css': {
        'type': "css",
        'path': "datatablecube-min.css"
    },

    'iqreport_graph_datatablecube': {
        'type': 'js',
        'path': 'graph_datatablecube-min.js',
        'requires': ['iqreport_graph_datatablecube_scss']
    },

    'iqreport_graph_datatablecube_scss': {
        'type': 'scss',
        'path': 'graph_datatablecube-min.scss',
        'requires': []
    },

    'iqreport_graph_table': {
        'type': 'js',
        'path': 'graph_table-min.js',
        'requires': []
    },

    'iqreport_graph': {
        'type': 'js',
        'path': 'graph-min.js',
        'requires': ['iq_report_env', 'iq_chart_legend', 'iqreport_graph_css']
    },

    'iqreport_graph_css': {
        'type': 'css',
        'path': 'graph-min.css'
    },


    'iqreport_fusion': {
        'type': 'js',
        'path': 'iqreport_fusion-min.js',
        'requires': ['iq_report_env', 'iqreport_fusion_css','iqube_formatters']
    },

    'iqreport_fusion_css': {
        'type': 'css',
        'path': 'iqreport_fusion-min.css'
    },


    'iqreport_graph_properties': {
        'type': 'js',
        'path': 'graph_properties-min.js',
        'requires': ['iq_report_env', 'iq_form_manager', 'colorpicker']
    },

    'iqreport_fusioncharts_properties': {
        'type': 'js',
        'path': 'fusioncharts_properties-min.js',
        'requires': ['iq_report_env', 'iq_form_manager', 'colorpicker']
    },

    'iqreport_graph_datatablecube_properties': {
        'type': 'js',
        'path': 'graph_datatablecube_properties-min.js',
        'requires': ['iq_report_env', 'iq_form_manager', 'colorpicker']
    },

    'iqreport_canvas': {
        'type': "js",
        'path': "canvas-min.js",
        'requires': [
            # Important: here should NOT be loaded the modules that are only needed in compose mode (palette, infobox, ..)
            # but only the ones that are required in BOTH response and compose mode
            # for compose modules see compose/js_modules.py
            'iqreport_canvas_css', 'iq_compose',
            'iqreport_canvas_block', 'iqreport_canvas_column', 'iqreport_canvas_item', 'iqreport_canvas_result',
            'dynamic_table_report_item'

        ]
    },

    'iqreport_canvas_css': {
        'type': "css",
        'path': "canvas-min.css"
    },

    # report block
    # important: dont depend on block, column or item
    'iqreport_canvas_block': {
        'type': "js",
        'path': "block-min.js",
        'requires': ['iqreport_canvas_block_css', 'iq_compose']
    },

    'iqreport_canvas_block_css': {
        'type': "css",
        'path': "block-min.css"
    },

    # report column
    'iqreport_canvas_column': {
        'type': "js",
        'path': "column-min.js",
        'requires': ['iqreport_canvas_column_css', 'iq_compose']
    },
    'iqreport_canvas_column_css': {
        'type': "css",
        'path': "column-min.css"
    },

    # report item
    'iqreport_canvas_item': {
        'type': "js",
        'path': "item-min.js",
        'requires': ['iqreport_canvas_item_css', 'iq_compose']
    },

    'iqreport_canvas_item_css': {
        'type': "css",
        'path': "item-min.css"
    },

    'dynamic_table_report_item': {
        'type': "js",
        'path': "item_dynamic_table-min.js",
        'requires': ['iqreport_canvas_item','abstract_dynamic_table_item']
    },

    # result
    'iqreport_canvas_result': {
        'type': "js",
        'path': "item_result-min.js",
        'requires': ['configurable_report_item']
    },

    'iqreport_canvas_result_css': {
        'type': "css",
        'path': "item_result-min.css"
    },

    # report manager
    'iqreport_report_manager': {
        'type': 'js',
        'path': 'report_manager-min.js',
        'requires': ['iq_custom_query', 'iq_manager']
    },

    'iqreport_publication_manager_scss': {
        'type': "scss",
        'path': "publication_manager-min.scss",
        'requires': ['iq_customdatatable_mixins_scss']
    },

    # report manager
    'iqreport_manager': {
        'type': 'js',
        'path': 'report_manager-min.js',
        'requires': ['iq_custom_query', 'iq_manager']
    },

    # report publication manager
    'iqreport_publication_manager': {
        'type': 'js',
        'path': 'publication_manager-min.js',
        'requires': ['iq_custom_query', 'iq_manager', 'iqreport_publication_manager_scss']
    },

    'iqreport_publication': {
        'type': "js",
        'path': "report_publication-min.js",
        'requires': []
    },

    'iqreport_publication_wizard': {
        'type': "js",
        'path': "report_publication_wizard-min.js",
        'requires': ['compose_publication_wizard', 'iqreport_publication']
    },

    'iq_db_report_publish_overview_widget': {
        'type': "js",
        'path': "db_publication_overview-min.js",
        'requires': ['iqreport_publication_manager']
    },

    'iq_db_report_manager': {
        'type': "js",
        'path': "db_report_manager-min.js",
        'requires': ['iqreport_manager']
    },

    # mdx result;
    'iqreport_mdx_result': {
        'type': 'js',
        'path': 'mdx_result-min.js',
        'requires': ['iqreport_datatablecube', 'iqreport_mdx_result_css']
    },

    'iqreport_mdx_result_css': {
        'type': 'css',
        'path': 'mdx_result-min.css'
    },

    'abstract_dynamic_table_item': {
        'type': "js",
        'path': "abstract_dynamic_table_item-min.js",
        'requires': ['iq_dynamictable', 'iqreport_mdx_result']
    },

    'db_dynamic_table': {
        'type': "js",
        'path': "db_dynamic_table-min.js",
        'requires': ['abstract_dynamic_table_item']
    },

    'iqreport_cubetable_membertree': {
        'type': "js",
        'path': "cubetable_membertree-min.js",
        'requires': [
            'iqube_member_tree', "iq_dragdrop", 'iqube_cube_table'
        ]
    },

    'db_item_result': {
        'type': "js",
        'path': "db_item_result-min.js",
        'requires': ['iqube_db_configurable_widget']
    },

}

def modules():
    dynamic_modules = {
        'iqreport_canvas_theme_basesoft': {
            'type': 'css',
            'path': 'themes/basesoft-min.css'
        },
        'iqreport_canvas_theme_summer': {
            'type': 'css',
            'path': 'themes/summer-min.css'
        },
        'iqreport_canvas_theme_winter': {
            'type': 'css',
            'path': 'themes/winter-min.css'
        },
        'iqreport_canvas_theme_debug': {
            'type': 'css',
            'path': 'themes/debug-min.css'
        },

    }

    # Merge base_modules into dynamic_modules
    # not the other way around cuz that would modify base_modules!
    dynamic_modules.update(base_modules)

    return dynamic_modules

