# Copyright (c) 2012 BaseSoft B.V.
# See LICENSE for details.

from basesoft import logging
from basesoft.web.contrib.i18n import models as i18n_models
from iqportal.iqreport.display.controllers import ReportDisplayController

logger = logging.getLogger("iqportal.iqreport.display")


class DefaultReportViewerHandler:
    def __init__(self, request, **kwargs):
        self.sa_session = request.Session()
        self._request = request

    def load(self, invitee_hash):

        # FIXME: locale from session #3238
        locale = self.sa_session.query(i18n_models.Locale).filter_by(locale='en_GB').one()

        report_viewer_id = None
        if self._request.session.has_key('report_viewer_id'):
            report_viewer_id = self._request.session['report_viewer_id']

        controller = ReportDisplayController(self.sa_session, locale, invitee_hash, report_viewer_id)
        self._request.session['report_viewer_id'] = controller.get_report_viewer().id

        # return the state and responses
        return controller.load_state()

handlers = (DefaultReportViewerHandler, )
