# Copyright (c) 2011 BaseSoft B.V.
# See LICENSE for details.

from sqlalchemy.orm import interfaces, attributes
from django.conf import settings

class MdxMemberMapper(interfaces.MapperExtension):

    def after_update(self, mapper, connection, instance):
        if not hasattr(instance, 'get_mdx_member_config'):
            return

        # get the config
        configs = instance.get_mdx_member_config()

        for config in configs:
            datasource = config['datasource']
            cube = config['cube']
            new_definition = '%s.[%s]' % (config['prefix'], getattr(instance, config['field']))

            history = attributes.get_history(instance, config['field'])
            if len(history[2]) > 0:
                # history is a tuple of 3, last elem being list with removed values
                old_definition = '%s.[%s]' % (config['prefix'], history[2][0])

                sql = "UPDATE tblMdxMember SET `definition`=%s WHERE `cube`=%s AND `definition`=%s AND "+\
                      "`datasource_id` IN (SELECT `id` FROM `tblDataSource` WHERE `name`=%s) AND "+\
                      "`id` NOT IN (SELECT `grouped_member_id` from `tblMdxMemberMember`)"
                connection.execute(sql, new_definition, cube, old_definition, '%s.%s' % (settings.SETTINGS_MODULE, datasource))
