'''
Created on Jun 4, 2014

@author: marten
'''
from sqlalchemy.orm import mapper

from sqlalchemy import Column, Integer, ForeignKey

from basesoft.sqlalchemy.table import IQTable
from basesoft.web.contrib.license import models as license_models
from basesoft.web.contrib.file import models as file_models

from iqportal.iqube.optiq import models as optiq_models
from iqportal.iqube.core.models import DataSource

__mapping_defined = False
__tables_defined = False
tables = {}

def reset():
    global __mapping_defined
    global __tables_defined

    __mapping_defined = False
    __tables_defined = False

def get_tables():
    return tables

def do_tables(metadata):
    global __tables_defined
    if __tables_defined:
        return

    __tables_defined = True

def do_mappings():
    """
    This function is called by Django middleware when needed.
    """
    global __mapping_defined
    if __mapping_defined:
        return

    from sqlalchemy.orm import mapper, relation


    __mapping_defined = True

def fill_data(conn):
    pass

def app_permissions_category():
    """
    Returns a category for all permissions defined for this app
    """
    return license_models.PermissionCategory(u'IQube Optiq')

def app_permissions():
    """
    The permissions used within this application. Can be sync'd with the
    `iqsyncpermissions` command.
    """
    return []
