# Copyright (c) 2010 BaseSoft B.V.
# See LICENSE for details.


import os
import commands

from django.conf import settings

from basesoft.scheduler.task import ScheduleTask
from basesoft import logging

from iqportal.iqube.core.models import DataSource
from iqportal.iqube.core.controllers import IQubeController
from sqlalchemy.sql.expression import and_
logger = logging.getLogger("iqportal.iqube.xmla")

class XmlaCacheCleanup(ScheduleTask):

    INTERVAL = 1800 # every minute

    def execute(self):

        datasources = self.sa_session.query(DataSource)
        for ds in datasources:

            # if the expiry is None then dont remove files. another task should take care of this
            if ds.xmla_cache_expiry is None:
                continue

            # let the datasource controller remove files older than x minutes
            c = IQubeController()
            project = self.sa_session.query(DataSource).filter(and_(DataSource.name==ds.name)).one()
            c.clear_xmla_cache(project.mondrian_project, ds.xmla_cache_expiry)


tasks = (XmlaCacheCleanup, )
