# Copyright (c) 2008 BaseSoft B.V.
# See LICENSE for details.

from basesoft.web.contrib.mailing.controllers import MailBaseController, AbstractMailStateController
from iqportal.iquest.core.models import IQuestMail

class IQuestMailStateController(AbstractMailStateController):
    """
    Takes care of the IQuestMail states
    """
    _instance_class = IQuestMail

    # permissions needed for using this kind of mail
    CREATE_ACCESS_PERMISSIONS   = ['create_iquest_mail']
    VIEW_ACCESS_PERMISSIONS     = ['view_iquest_mail']
    UPDATE_ACCESS_PERMISSIONS   = ['update_iquest_mail']
    DELETE_ACCESS_PERMISSIONS   = ['delete_iquest_mail']
    SCHEDULE_ACCESS_PERMISSIONS = ['schedule_iquest_mail']

class MailController(MailBaseController):
    """
    Class that's on top of the MailBaseController. This is used for
    handling IQuestMail objects.
    """
    # mapping between object type and the controller
    _state_controllers = {
        'IQuestMail': IQuestMailStateController,
    }

