'''
Created on 7 Oct 2011

@author: martijn
'''
from sqlalchemy import and_
from basesoft.web.core.util.controllers import AbstractController
from basesoft.web.contrib.compose.models import ComposeInvitee, ComposePublicationGroup
from iqportal.iquest.core.models import Survey, SurveyPublication
from basesoft.web.core.exceptions import SecurityException
from iqportal.iquest.response.controllers import PublicationResponseController

class IQuestMobileController(AbstractController):

    def get_all_surveys(self):

        return self._get_privileged_object(Survey)

    def get_offline_publications(self):

        self.assert_permissions('view_survey')
        self.assert_permissions('view_survey_publication')

        filter, fo = self.get_query_filter_on_privileges(SurveyPublication, ComposePublicationGroup, SurveyPublication.PRIV_OFFLINE)
        filter = and_(filter, SurveyPublication.status==SurveyPublication.STATUS_ONLINE, SurveyPublication.anonymous==True)

        return self.sa_session.query(SurveyPublication).select_from(fo).filter(filter).all()

    def save_responses(self, publication_id, responses):
        publication = self.get_privileged_object_by_id(SurveyPublication, publication_id, SurveyPublication.PRIV_CREATE_RESPONSE)
        if len(publication) == 0:
            raise SecurityException('Invalid publication id %s' % publication_id)
        publication = publication[0]
        if not publication.anonymous:
            raise SecurityException('Cannot save responses for a non anonymous survey')
        invitee = self.sa_session.query(ComposeInvitee).filter(ComposeInvitee.invitee_hash==publication.anonymous_hash).one()
        pc = PublicationResponseController(self.sa_session, self.get_account().id)
        ret = []
        for response in responses:
            try:
                v = pc.update_responses(invitee.id, response, None, True)
                if v is None:
                    ret.append('OK')
                else:
                    ret.append(v)
            except Exception, e:
                ret.append(e.message)
        return ret
