# Copyright (c) 2011 BaseSoft B.V.
# See LICENSE for details.

from django.utils.translation import ugettext_lazy as _

from basesoft.web.contrib.account.decorators import assert_user_logged_in
from basesoft.web.mobile.models import MobileIcon

class IQuestMobileIcon(MobileIcon):
    """
    """

    id = 'icon-mobile-iquest'
    name = 'mobile-iquest'
    title = _('IQuest')
    desc = _('Run offline surveys and synchronize the responses later')
    image = '/site_media/iqportal.iquest.compose/img/75x75/iqportal.png'
    icon_index = 2
    js_module = 'mobile_app_iquest'

    #@assert_user_logged_in
    def has_permissions(self, controller):
        """
        this is shown only if the permissions are met
        """
        return True

def get_icons():
    return [IQuestMobileIcon()]
