# Copyright (c) 2012 BaseSoft B.V.
# See LICENSE for details.

from iqportal.iqube.xmla import client as iqube_client
from iqportal.iquest.report.controllers import IQuestIQReportXMLACacheController
from basesoft.web.core.util.db import Session
from iqportal.iqube.core.controllers import ProjectController

class XMLAClient(iqube_client.XMLAClient):
    _xmla_cache_controller = IQuestIQReportXMLACacheController

    DEFAULT_CUBE = 'VirtualFilteredResponse'


    def __get_cube(self, cube):
        if self.account_id is None:
            return cube
        sa_session = Session()
        pc = ProjectController(sa_session, account_id=self.account_id)
        cubes = pc.get_cubes(self.project)
        if cube not in [c.name for c in cubes]:
            return self.DEFAULT_CUBE
        return cube

    def _discover(self, request_type, properties=None, restrictions=None):

        if restrictions is not None and restrictions.has_key('CUBE_NAME'):
            restrictions['CUBE_NAME'] = self.__get_cube(restrictions['CUBE_NAME'])

        return iqube_client.XMLAClient._discover(self, request_type, properties, restrictions)

    def build_select_statement(self, columns, rows, cube, slicers, nonempty, mdx_with=None, is_graph=False, allow_empty_rows=False, hierarchize=True):
        cube = self.__get_cube(cube)
        return iqube_client.XMLAClient.build_select_statement(self, columns, rows, cube, slicers, nonempty, mdx_with, is_graph, allow_empty_rows, hierarchize)
