# Copyright (c) 2011 BaseSoft B.V.
# See LICENSE for details.

from iqportal.iqube.core.schedule import AbstractAggregateTask
from iqportal.iquest.report.controllers import IQuestResponseFullAggregator, IQuestResponseFilteredAggregator, IQuestAggregator,\
    IQuestPublicationStatisticsAggregator

from django.conf import settings

from basesoft import logging
logger = logging.getLogger('iqportal.iquest.report.schedule')

class AggregateResponsesTask(AbstractAggregateTask):
    """
    re-populates and refreshes the iquest responses datasource
    """

    refresh_datasources = ('%s.IQuest' % settings.SETTINGS_MODULE, )

    def populate(self):

        affected_rows = 0

        c = IQuestResponseFullAggregator()
        self._aggregators.append(c)
        affected_rows = affected_rows + c.run(loop_validator=self.loop_validator)

        c = IQuestResponseFilteredAggregator()
        self._aggregators.append(c)
        affected_rows = affected_rows + c.run(loop_validator=self.loop_validator)

        c = IQuestAggregator()
        self._aggregators.append(c)
        affected_rows = affected_rows + c.run(loop_validator=self.loop_validator)

        c = IQuestPublicationStatisticsAggregator()
        self._aggregators.append(c)
        affected_rows = affected_rows + c.run(loop_validator=self.loop_validator)

        return affected_rows


tasks = (AggregateResponsesTask, )
