# Copyright (c) 2009 BaseSoft B.V.
# See LICENSE for details.
from django.utils.translation import ugettext_lazy as _

from basesoft.web.contrib.account.decorators import assert_user_logged_in
from basesoft.web.contrib.iconbar.models import IconBarIcon

class IQuestPublicationOverview(IconBarIcon):
    """
    Class responsible for generating the Publication Overview icon
    """

    id = 'icon-iquest-publication-overview'
    title = _('Publication Overview')
    icon_index = 32
    component = 'iquest_publication_manager'
    group = 'iquest'

    char_main = u'\uE805' # Layers icon

    @assert_user_logged_in
    def assert_permissions(self, controller):
        """
        this is shown only if the permissions are met
        """
        controller.assert_permissions('view_survey_publication')

def get_icons():
    """
    return the list of icons that the home app adds to the iconbar
    """

    return [IQuestPublicationOverview()]