# Copyright (c) 2011 BaseSoft B.V.
# See LICENSE for details.

from django.utils.translation import ugettext_lazy as _

from basesoft.web.contrib.account.decorators import assert_user_logged_in
from basesoft.web.contrib.iconbar.models import IconBarIcon

class XBRLManagerIcon(IconBarIcon):
    """
    Class responsible for handling the xbrl manager icon
    """

    id = 'icon-xbrl-manager'
    title = _('XBRL Project manager')
    image = 'icons/xbrlmanager.png'
    icon_index = 75
    component = 'xbrl_manager'
    group = 'xbrl'

    @assert_user_logged_in
    def assert_permissions(self, controller):
        """
        """
        controller.assert_permissions('view_xbrl_project')

def get_icons():
    return [XBRLManagerIcon(),]